// -------------------------------------------------------------------------------
// 
// 		cwCu		`揈vO( Android )wb_t@C
// 
// 				Ver 3.21 
// 
// -------------------------------------------------------------------------------

#ifndef DX_GRAPHICSANDROID_H
#define DX_GRAPHICSANDROID_H


#include "../DxCompileConfig.h"

#ifndef DX_NON_GRAPHICS

// CN[h ------------------------------------------------------------------
#include "../DxLib.h"
#include "../DxGraphics.h"
#include "../DxArchive_.h"
#include <EGL/egl.h>
#include <GLES2/gl2.h>
#include "DxShader_DataType_Android.h"
#include "DxShader_FS_Android.h"
#include "DxShader_VS_Android.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

#define GANDR										GraphicsHardDataAndroid

// Graphics_Android_DrawPreparation ֐ɓntO
#define DX_ANDROID_DRAWPREP_TRANS						(0x00001)
#define DX_ANDROID_DRAWPREP_VECTORINT					(0x00002)
#define DX_ANDROID_DRAWPREP_GOURAUDSHADE				(0x00008)
#define DX_ANDROID_DRAWPREP_PERSPECTIVE					(0x00010)
#define DX_ANDROID_DRAWPREP_DIFFUSERGB					(0x00020)
#define DX_ANDROID_DRAWPREP_DIFFUSEALPHA				(0x00040)
#define DX_ANDROID_DRAWPREP_FOG							(0x00080)
#define DX_ANDROID_DRAWPREP_NOBLENDSETTING				(0x00100)
#define DX_ANDROID_DRAWPREP_LIGHTING					(0x00200)
#define DX_ANDROID_DRAWPREP_SPECULAR					(0x00400)
#define DX_ANDROID_DRAWPREP_3D							(0x00800)
#define DX_ANDROID_DRAWPREP_TEXADDRESS					(0x01000)
#define DX_ANDROID_DRAWPREP_NOTSHADERRESET				(0x02000)
#define DX_ANDROID_DRAWPREP_CULLING						(0x04000)
#define DX_ANDROID_DRAWPREP_TEXTURE						(0x08000)
#define DX_ANDROID_DRAWPREP_TEXALPHACH					(0x10000)
#define DX_ANDROID_DRAWPREP_TEXALPHATEST				(0x20000)

// tOgVF[_[̃At@eXg[h
#define ANDROID_FS_ALPHATEST_CMP_GREATER				(0)				// `At@leXgAt@l傫Ε`
#define ANDROID_FS_ALPHATEST_CMP_OTHER					(1)				// GREATER ȊO̔r[h
#define ANDROID_FS_ALPHATEST_NUM						(2)

// GL Extensions
#define ANDROID_GL_EXTENSION_DEPTH24						(0)				// GL_OES_depth24
#define ANDROID_GL_EXTENSION_DEPTH32						(1)				// GL_OES_depth32
#define ANDROID_GL_EXTENSION_ELEMENT_INDEX_UNIT				(2)				// GL_OES_element_index_uint
#define ANDROID_GL_EXTENSION_TEXTURE_FLOAT					(3)				// GL_OES_texture_float
#define ANDROID_GL_EXTENSION_TEXTURE_FLOAT_LINEAR			(4)				// GL_OES_texture_float_linear
#define ANDROID_GL_EXTENSION_COMPRESSED_PALETTED_TEXTURE	(5)				// GL_OES_compressed_paletted_texture
#define ANDROID_GL_EXTENSION_COMPRESSED_ETC1_RGB8_TEXTURE	(6)				// GL_OES_compressed_ETC1_RGB8_texture
#define ANDROID_GL_EXTENSION_DEPTH_TEXTURE					(7)				// GL_OES_depth_texture
#define ANDROID_GL_EXTENSION_TEXTURE_HALF_FLOAT				(8)				// GL_OES_texture_half_float
#define ANDROID_GL_EXTENSION_TEXTURE_HALF_FLOAT_LINEAR		(9)				// GL_OES_texture_half_float_linear
#define ANDROID_GL_EXTENSION_VERTEX_HALF_FLOAT				(10)			// GL_OES_vertex_half_float
#define ANDROID_GL_EXTENSION_TEXTURE_3D						(11)			// GL_OES_texture_3D
#define ANDROID_GL_EXTENSION_TEXTURE_FORMAT_BGRA8888		(12)			// GL_EXT_texture_format_BGRA8888
#define ANDROID_GL_EXTENSION_NUM							(13)

// sNZtH[}bg
#define ANDROID_PIXEL_FORMAT_R8G8B8A8					(0)
#define ANDROID_PIXEL_FORMAT_R8G8B8						(1)
#define ANDROID_PIXEL_FORMAT_A4B4G4R4					(2)
#define ANDROID_PIXEL_FORMAT_A1B5G5R5					(3)
#define ANDROID_PIXEL_FORMAT_B5G6R5						(4)
#define ANDROID_PIXEL_FORMAT_R8G8B8_PAL4				(5)
#define ANDROID_PIXEL_FORMAT_R8G8B8_PAL8				(6)
#define ANDROID_PIXEL_FORMAT_R8G8B8A8_PAL4				(7)
#define ANDROID_PIXEL_FORMAT_R8G8B8A8_PAL8				(8)
#define ANDROID_PIXEL_FORMAT_A1B5G5R5_PAL4				(9)
#define ANDROID_PIXEL_FORMAT_A1B5G5R5_PAL8				(10)
#define ANDROID_PIXEL_FORMAT_R8							(11)
#define ANDROID_PIXEL_FORMAT_R16G16B16_FLOAT			(12)
#define ANDROID_PIXEL_FORMAT_R32G32B32_FLOAT			(13)
#define ANDROID_PIXEL_FORMAT_R16G16B16A16_FLOAT			(14)
#define ANDROID_PIXEL_FORMAT_R32G32B32A32_FLOAT			(15)
#define ANDROID_PIXEL_FORMAT_NUM						(16)

// W`撸_tH[}bg
#define ANDROID_VERTEX_INPUTLAYOUT_NOTEX_2D				(0)				// ( VERTEX_NOTEX_2D                      \̌` )CA{bNX`p_tH[}bg
#define ANDROID_VERTEX_INPUTLAYOUT_2D					(1)				// ( VERTEX2D or VERTEX_2D                \̌` )gXtH[ςݒ_tH[}bg
#define ANDROID_VERTEX_INPUTLAYOUT_BLENDTEX_2D			(2)				// ( VERTEX_BLENDTEX_2D or VERTEX2DSHADER \̌` )uheNX`tgXtH[ςݒ_tH[}bg
#define ANDROID_VERTEX_INPUTLAYOUT_NOTEX_3D				(3)				// ( VERTEX_NOTEX_3D                      \̌` )CA{bNX`p_tH[}bgARcp( o[Wp )
#define ANDROID_VERTEX_INPUTLAYOUT_3D					(4)				// ( VERTEX_3D                            \̌` )OtBbNX`p_tH[}bgARcp( o[Wp )
#define ANDROID_VERTEX_INPUTLAYOUT_3D_LIGHT				(5)				// ( VERTEX3D                             \̌` )OtBbNX`p_tH[}bg
#define ANDROID_VERTEX_INPUTLAYOUT_SHADER_3D			(6)				// ( VERTEX3DSHADER                       \̌` )VF[_[`p_tH[}bg
#define ANDROID_VERTEX_INPUTLAYOUT_NUM					(7)

// `^Cv
#define ANDROID_RENDER_TYPE_NORMAL						(0)				// 0:ʏ`
#define ANDROID_RENDER_TYPE_MUL							(1)				// 1:Z`
#define ANDROID_RENDER_TYPE_INVERSE						(2)				// 2:RGB]
#define ANDROID_RENDER_TYPE_X4							(3)				// 3:`Px4{
#define ANDROID_RENDER_TYPE_PMA_NORMAL					(4)				// 4:Zς݃uh[h̒ʏ`
#define ANDROID_RENDER_TYPE_PMA_INVERSE					(5)				// 5:Zς݃uh[hRGB]
#define ANDROID_RENDER_TYPE_PMA_X4						(6)				// 6:Zς݃uh[h̕`Px4{
#define ANDROID_RENDER_TYPE_NUM							(7)

// _f[^
#define ANDROID_VERTEX_ATTR_POS_F2								(0)			// W( x, y )
#define ANDROID_VERTEX_ATTR_POS_F3								(1)			// W( x, y, z )
#define ANDROID_VERTEX_ATTR_POS_F4								(2)			// W( x, y, z, w )
#define ANDROID_VERTEX_ATTR_NRM									(3)			// @
#define ANDROID_VERTEX_ATTR_DIF									(4)			// fBt[YJ[
#define ANDROID_VERTEX_ATTR_SPC									(5)			// XyLJ[
#define ANDROID_VERTEX_ATTR_TEXUV0_F2							(6)			// eNX`WO( x, y )
#define ANDROID_VERTEX_ATTR_TEXUV1_F2							(7)			// eNX`WP( x, y )
#define ANDROID_VERTEX_ATTR_TEXUV2_F2							(8)			// eNX`WQ( x, y )
#define ANDROID_VERTEX_ATTR_TEXUV3_F2							(9)			// eNX`WR( x, y )
#define ANDROID_VERTEX_ATTR_TEXUV4_F2							(10)		// eNX`WS( x, y )
#define ANDROID_VERTEX_ATTR_TEXUV5_F2							(11)		// eNX`WT( x, y )
#define ANDROID_VERTEX_ATTR_TEXUV6_F2							(12)		// eNX`WU( x, y )
#define ANDROID_VERTEX_ATTR_TEXUV7_F2							(13)		// eNX`WV( x, y )
#define ANDROID_VERTEX_ATTR_TEXUV0_F4							(14)		// eNX`WO( x, y, z, w )
#define ANDROID_VERTEX_ATTR_TEXUV1_F4							(15)		// eNX`WP( x, y, z, w )
#define ANDROID_VERTEX_ATTR_TAN									(16)		// ڐ( [J )
#define ANDROID_VERTEX_ATTR_BIN									(17)		// ]@( [J )
#define ANDROID_VERTEX_ATTR_BLENDIND0							(18)		// {[p Float^萔zCfbNXO
#define ANDROID_VERTEX_ATTR_BLENDWEIGHT0						(19)		// {[pEGCglO
#define ANDROID_VERTEX_ATTR_BLENDIND1							(20)		// {[p Float^萔zCfbNXP
#define ANDROID_VERTEX_ATTR_BLENDWEIGHT1						(21)		// {[pEGCglP
#define ANDROID_VERTEX_ATTR_NUM									(22)
#define ANDROID_VERTEX_ATTR_OTHER								(-1)

// VF[_[̒萔
#define ANDROID_SHADER_UNIFORM_SRC_TEX							(0)			// \[XeNX`
#define ANDROID_SHADER_UNIFORM_BLEND_TEX						(1)			// uheNX`
#define ANDROID_SHADER_UNIFORM_DIF_MAP_TEX						(2)			// fBt[Y}bveNX`
#define ANDROID_SHADER_UNIFORM_NRM_MAP_TEX						(3)			// @}bveNX`
#define ANDROID_SHADER_UNIFORM_SPC_MAP_TEX						(4)			// XyL}bveNX`
#define ANDROID_SHADER_UNIFORM_TOON_DIF_GRAD_TEX				(5)			// gD[_OpfBt[YJ[Of[VeNX`
#define ANDROID_SHADER_UNIFORM_TOON_SPC_GRAD_TEX				(6)			// gD[_OpXyLJ[Of[VeNX`
#define ANDROID_SHADER_UNIFORM_TOON_SPHERE_MAP_TEX				(7)			// gD[_OpXtBA}bveNX`
#define ANDROID_SHADER_UNIFORM_TOON_RGB_TO_VMAXRGBVOL_TEX		(8)			// gD[_OpRGBPxOap{[eNX`
#define ANDROID_SHADER_UNIFORM_SUB_TEX							(9)			// TueNX`
#define ANDROID_SHADER_UNIFORM_SHADOW_MAP0_TEX					(10)		// VhE}bv0eNX`
#define ANDROID_SHADER_UNIFORM_SHADOW_MAP1_TEX					(11)		// VhE}bv1eNX`
#define ANDROID_SHADER_UNIFORM_SHADOW_MAP2_TEX					(12)		// VhE}bv2eNX`
#define ANDROID_SHADER_UNIFORM_AMB_EMI							(13)		// G~bVuJ[{ArGgJ[( G~bVuJ[ + }eAArGgJ[ * O[oArGgJ[ )
#define ANDROID_SHADER_UNIFORM_MAT_DIF							(14)		// fBt[YJ[
#define ANDROID_SHADER_UNIFORM_MAT_SPC							(15)		// XyLJ[
#define ANDROID_SHADER_UNIFORM_MAT_POW							(16)		// XyL̋
#define ANDROID_SHADER_UNIFORM_MAT_TYPE_PARAM0					(17)		// }eAp[^0
#define ANDROID_SHADER_UNIFORM_MAT_TYPE_PARAM1					(18)		// }eAp[^1
#define ANDROID_SHADER_UNIFORM_MAT_TYPE_PARAM2					(19)		// }eAp[^2
#define ANDROID_SHADER_UNIFORM_LIGHT_POS						(20)		// W( r[ )
#define ANDROID_SHADER_UNIFORM_LIGHT_DIR						(21)		// ( r[ )
#define ANDROID_SHADER_UNIFORM_LIGHT_DIF						(22)		// fBt[YJ[
#define ANDROID_SHADER_UNIFORM_LIGHT_SPC						(23)		// XyLJ[
#define ANDROID_SHADER_UNIFORM_LIGHT_AMB						(24)		// ArGgJ[
#define ANDROID_SHADER_UNIFORM_LIGHT_RANGE_FALLOFF_AT0_AT1		(25)		// x:L  y:X|bgCgpFllOff  z:ɂ錸pp[^O  w:ɂ錸pp[^P
#define ANDROID_SHADER_UNIFORM_LIGHT_AT2_SPOTP0_SPOTP1			(26)		// x:ɂ錸pp[^Q  y:X|bgCgpp[^O( cos( Phi / 2.0 ) )  z:X|bgCgpp[^P( 1.0 / ( cos( Theta / 2.0 ) - cos( Phi / 2.0 ) ) )
#define ANDROID_SHADER_UNIFORM_ANTI_VIEW_PORT_MAT				(27)		// [h@@r[s
#define ANDROID_SHADER_UNIFORM_VIEW_MAT							(28)		// [h@@r[s
#define ANDROID_SHADER_UNIFORM_PROJ_MAT							(29)		// r[@@vWFNVs
#define ANDROID_SHADER_UNIFORM_FOG								(30)		// tHOpp[^( x:end/(end - start)  y:-1/(end - start)  z:density  w:Rΐ̒ )
#define ANDROID_SHADER_UNIFORM_TOON_OUTLINE_SIZE				(31)		// gD[̗֊s̑傫
#define ANDROID_SHADER_UNIFORM_DIFSRC_SPCSRC_MULSPECOL			(32)		// x:fBt[YJ[( 0.0:}eA  1.0:_ )  y:XyLJ[(   0.0:}eA  1.0:_ )  z:XyLJ[lɏZl( XyLŎgp )
#define ANDROID_SHADER_UNIFORM_SM_LVP_MAT						(33)		// VhE}bvp̃Cgr[sƃCgˉesZ
#define ANDROID_SHADER_UNIFORM_TEX_MAT							(34)		// eNX`Wps
#define ANDROID_SHADER_UNIFORM_LW_MAT							(35)		// [J@@[hs
#define ANDROID_SHADER_UNIFORM_MUL_ALPHA_COLOR					(36)		// J[ɃAt@lZ邩ǂ( 0.0:ZȂ  1.0:Z )
#define ANDROID_SHADER_UNIFORM_ALPHA_TEST_REF					(37)		// eXgl
#define ANDROID_SHADER_UNIFORM_ALPHA_TEST_CMPMODE				(38)
#define ANDROID_SHADER_UNIFORM_FOG_COLOR						(39)		// tHOJ[
#define ANDROID_SHADER_UNIFORM_FACTOR_COLOR						(40)		// t@N^[J[
#define ANDROID_SHADER_UNIFORM_IGNORE_TEXTURE_COLOR				(41)		// eNX`J[pJ[
#define ANDROID_SHADER_UNIFORM_SHADOWMAP_LIGHT_ENABLE			(42)		// VhE}bvOEPEQ̃CgL( x:VhE}bvOŃCgnL  y:VhE}bvPŃCgnL  z:VhE}bvQŃCgnL )
#define ANDROID_SHADER_UNIFORM_SHADOWMAP_DADJ_GRAD				(43)		// VhE}bv̏( x:臒l[x␳l  y:Of[V͈  )
#define ANDROID_SHADER_UNIFORM_NUM								(44)
#define ANDROID_SHADER_UNIFORM_OTHER							(-1)

// _obt@̃TCY
#define DX_GLES2_VERTBUFFERSIZE							(64 * 1024)		// 64KB

// VF[_[ Uniform Zbg̃wp[}N
#define UNIFORM_SET_MATRIX4( index, _matrix4 )	glUniformMatrix4fv( (index), 1, GL_FALSE, _matrix4 ) ;
#define UNIFORM_SET_FLOAT4(  index, _float4  )	glUniform4f(        (index), _float4[ 0 ], _float4[ 1 ], _float4[ 2 ], _float4[ 3 ] ) ;
#define UNIFORM_SET_FLOAT3(  index, _float3  )	glUniform3f(        (index), _float3[ 0 ], _float3[ 1 ], _float3[ 2 ] ) ;
#define UNIFORM_SET_FLOAT2(  index, _float2  )	glUniform2f(        (index), _float2[ 0 ], _float2[ 1 ] ) ;
#define UNIFORM_SET_FLOAT1(  index, _float1  )	glUniform1f(        (index), _float1 ) ;
#define UNIFORM_SET_INT1(    index, _int1    )	glUniform1i(        (index), _int1   ) ;

// GRAPHICS_ANDROID_SHADER_LIST Ɋ܂܂ GRAPHICS_ANDROID_SHADER ̐
#define SHADERS_LIST_DATA_NUM							(256)

// \̒` --------------------------------------------------------------------

// Androidp eNX`
struct GRAPHICS_ANDROID_TEXTURE
{
	GLuint							TextureBuffer ;							// eNX`obt@
	int								MipMapCount ;							// ~bv}bv( Level0 Ȃꍇ 1, Level1 ܂łꍇ 2 )
	int								PixelFormat ;							// eNX`̃sNZtH[}bg( ANDROID_PIXEL_FORMAT_R8G8B8A8 Ȃ )
	GLuint							Width ;									// eNX`̕
	GLuint							Height ;								// eNX`̍
	GLint							MagFilter ;								// gtB^[( GL_TEXTURE_MAG_FILTER ̃p[^A GL_NEAREST Ȃ )
	GLint							MinFilter ;								// ktB^[( GL_TEXTURE_MIN_FILTER ̃p[^A GL_NEAREST Ȃ )
	GLint							WrapS ;									// eNX`AhX[hr( GL_TEXTURE_WRAP_S ̃p[^A GL_REPEAT Ȃ )
	GLint							WrapT ;									// eNX`AhX[hs( GL_TEXTURE_WRAP_T ̃p[^A GL_REPEAT Ȃ )
	GLint							WrapR ;									// eNX`AhX[hq( GL_TEXTURE_WRAP_R ̃p[^A GL_REPEAT Ȃ )
} ;

// Androidp n[hEGA_OpIWi摜eNX`
struct IMAGEDATA_ORIG_HARD_TEX_PF
{
	GLuint							MSRenderTarget ;						// }`Tvp_[^[Qbg

	GLuint							FrameBuffer ;							// t[obt@
	GRAPHICS_ANDROID_TEXTURE		Texture ;								// eNX`
	GLuint							DepthBuffer ;							// [xobt@
} ;

// Androidp VhE}bv
struct SHADOWMAPDATA_PF
{
	GLuint							FrameBuffer ;							// [xlݗpt[obt@
	GRAPHICS_ANDROID_TEXTURE		Texture ;								// [xlݗpeNX`
	GLuint							DepthBuffer ;							// [xobt@
} ;

// sNZtH[}bg̏
struct PIXELFORMAT_INFO_ANDR
{
	int								IsExtFormat ;							// gtH[}bgǂ
	int								PixelBits ;								// PsNZ̃rbg
	int								AddDataBytes ;							// ǉ̃oCg( pbgȂ )
	GLint							InternalFormat ;						// GL_RGBA , GL_PALETTE4_RGB8_OES Ȃ
	GLenum							Format ;								// GL_RGBA Ȃ
	GLenum							Type ;									// GL_UNSIGNED_SHORT_4_4_4_4 Ȃ
} ;

// _f[^vf̊{
struct VERTEXBUFFER_INPUT_ELEMENT_INFO_BASE_ANDR
{
	const GLchar *								AttrName ;					// f[^
	GLint										Size ;						// f[^
	GLenum										DataFormat ;				// f[^`
	GLboolean									Normalized ;				// K邩ǂ
} ;

// _f[^vf̏
struct VERTEXBUFFER_INPUT_ELEMENT_INFO_ANDR
{
	int											ElementBase ;				// _{( ANDROID_VERTEX_ATTR_POS Ȃ )
	VERTEXBUFFER_INPUT_ELEMENT_INFO_BASE_ANDR *	OtherAttr ;					// vZbgɂȂ̏ꍇ̎QƐ( Attr  ANDROID_VERTEX_ATTR_OTHER ̏ꍇɎgp )
	GLuint										Offset ;					// ItZbg
} ;

// _VF[_[̓͏
struct VERTEXBUFFER_INPUT_INFO_ANDR
{
	GLuint										VertexDataSize ;			// _f[^̃oCg
	int											ElementInfoNum ;			// ͒_f[^̗vf
	VERTEXBUFFER_INPUT_ELEMENT_INFO_ANDR		ElementInfo[ 32 ] ;			// ͒_f[^
} ;

// Androidp _obt@nh
struct VERTEXBUFFERHANDLEDATA_PF
{
	GLuint							VertexBuffer ;
} ;

// Androidp CfbNXobt@nh
struct INDEXBUFFERHANDLEDATA_PF
{
	GLuint							IndexBuffer ;
} ;

// Android ̃VF[_[ӂ̏Z߂\
struct GRAPHICS_ANDROID_SHADER
{
	GLuint							Shader ;
	GLushort						AttributeIndex[ ANDROID_VERTEX_ATTR_NUM ] ;		// e_vfԖڂ̗vfƂȂĂ邩̏( 0xffffffff ̏ꍇ̗͂vfȂƂ )
	GLushort						UniformIndex[ ANDROID_SHADER_UNIFORM_NUM ] ;	// eVF[_[p萔vfԖڂ̗vfƂȂĂ邩̏( 0xffffffff ̏ꍇ̗͂vfȂƂ )
	int								ApplyUniformUpdateCount ;						// KpĂ萔̕ύXo[W
} ;

// Androidp VF[_[nh
struct SHADERHANDLEDATA_PF
{
	GLuint							Shader ;
} ;

// Androidp VF[_[p萔obt@nhˑ̍\
struct SHADERCONSTANTBUFFERHANDLEDATA_PF
{
	int								Dummy ;
} ;

// Android ̕W`p̃VF[_[Z߂\
struct GRAPHICS_HARDWARE_ANDROID_SHADER_BASE
{
	// W`p̕GȏsȂ_VF[_[
	GLuint						BaseSimple_VS[ ANDROID_VERTEX_INPUTLAYOUT_NUM ] ;

	// Œ@\pCvC݊̒_VF[_[( eNX`Ȃ )
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ tOgVF[_[̃At@eXg[h ]
	GLuint						BaseNoneTex_FS[ ANDROID_RENDER_TYPE_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// Œ@\pCvC݊̃VF[_[( eNX`Ȃ )
	// [ W`撸_tH[}bg ]
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_ANDROID_SHADER		*BaseNoneTex_Shader[ ANDROID_VERTEX_INPUTLAYOUT_NUM ][ ANDROID_RENDER_TYPE_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// Œ@\pCvC݊̃tOgVF[_[( eNX` )
	// [ uh摜Ƃ̃uh^Cv( 0:Ȃ  1:DX_BLENDGRAPHTYPE_NORMAL  2:DX_BLENDGRAPHTYPE_WIPE  3:DX_BLENDGRAPHTYPE_ALPHA ) ]
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ eNX`RGB( 0:Ȃ  1: ) ]
	// [ eNX`Alpha( 0:Ȃ  1: ) ]
	// [ tOgVF[_[̃At@eXg[h ]
	GLuint						BaseUseTex_FS[ 4 ][ ANDROID_RENDER_TYPE_NUM ][ 2 ][ 2 ][ ANDROID_FS_ALPHATEST_NUM ] ; 

	// Œ@\pCvC݊̃VF[_[( eNX` )
	// [ W`撸_tH[}bg ]
	// [ uh摜Ƃ̃uh^Cv( 0:Ȃ  1:DX_BLENDGRAPHTYPE_NORMAL  2:DX_BLENDGRAPHTYPE_WIPE  3:DX_BLENDGRAPHTYPE_ALPHA ) ]
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ eNX`RGB( 0:Ȃ  1: ) ]
	// [ eNX`Alpha( 0:Ȃ  1: ) ]
	// [ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_ANDROID_SHADER		*BaseUseTex_Shader[ ANDROID_VERTEX_INPUTLAYOUT_NUM ][ 4 ][ ANDROID_RENDER_TYPE_NUM ][ 2 ][ 2 ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// }XNpVF[_[
	GRAPHICS_ANDROID_SHADER		MaskEffect_Shader ;
	GRAPHICS_ANDROID_SHADER		MaskEffect_ReverseEffect_Shader ;
	GRAPHICS_ANDROID_SHADER		MaskEffect_UseGraphHandle_Shader[ 4 ] ;
	GRAPHICS_ANDROID_SHADER		MaskEffect_UseGraphHandle_ReverseEffect_Shader[ 4 ] ;

	// P]pVF[_[
	GLuint		StretchRect_VS ;
	GLuint		StretchRectTex2_VS ;
	GLuint		StretchRectTex8_VS ;
	GRAPHICS_ANDROID_SHADER		StretchRect_Shader ;

	// _[^[QbgNApVF[_[
	GRAPHICS_ANDROID_SHADER		ClearRT_Shader ;
} ;

// Android ̕WRc`p̃VF[_[Z߂\
struct GRAPHICS_HARDWARE_ANDROID_SHADER_BASE3D
{
	// WRc`psNZPʃCeBO^Cv̒_VF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	GLuint		Base3D_PixelLighting_VS[ 2 ][ 4 ] ;

	// WRc`psNZPʃCeBO^CṽtOgVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ CgCfbNX ]
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ tOgVF[_[̃At@eXg[h ]
	GLuint		Base3D_PixelLighting_Normal_FS[ 2 ][ 84 ][ ANDROID_RENDER_TYPE_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// WRc`psNZPʃCeBO^CṽVF[_[( Xg͔z̍ )
	// VhE}bv̗L( 0: 1:L )
	// _VF[_[[ tHO^Cv ]
	// tOgVF[_[[ CgCfbNX ]
	// tOgVF[_[[ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// tOgVF[_[[ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_ANDROID_SHADER		*Base3D_PixelLighting_Normal_Shader[ 2 ][ 4 ][ 84 ][ ANDROID_RENDER_TYPE_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;



	// WRc`p̃VhE}bvւ̃_Op_VF[_[
	// [ ov}bv̗L( 0: 1:L ) ]
	GLuint		Base3D_ShadowMap_VS[ 2 ] ;

	// WRc`p̃VhE}bvւ̃_OptOgVF[_[
	// [ tOgVF[_[̃At@eXg[h ]
	GLuint		Base3D_ShadowMap_Normal_FS[ ANDROID_FS_ALPHATEST_NUM ] ;

	// WRc`p̃VhE}bvւ̃_OpVF[_[
	// _VF[_[[ ov}bv̗L( 0: 1:L ) ]
	// tOgVF[_[[ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_ANDROID_SHADER		*Base3D_ShadowMap_Normal_Shader[ 2 ][ ANDROID_FS_ALPHATEST_NUM ] ;



	// WRc`p̃CeBOȂ_VF[_[
	// [ tHO^Cv ]
	GLuint		Base3D_NoLighting_VS[ 4 ] ;

	// WRc`p̃CeBOȂtOgVF[_[
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ tOgVF[_[̃At@eXg[h ]
	GLuint		Base3D_NoLighting_Normal_FS[ ANDROID_RENDER_TYPE_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// WRc`p̃CeBOȂVF[_[
	// _VF[_[[ tHO^Cv ]
	// tOgVF[_[[ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// tOgVF[_[[ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_ANDROID_SHADER		*Base3D_NoLighting_Normal_Shader[ 4 ][ ANDROID_RENDER_TYPE_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;



	// WRc`p̒_PʃCeBO_VF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	// [ CgCfbNX ]
	GLuint		Base3D_VertexLighting_VS[ 2 ][ 4 ][ 20 ] ;

	// WRc`p̒_PʃCeBOtOgVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ CgCfbNX ]
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ tOgVF[_[̃At@eXg[h ]
	GLuint		Base3D_VertexLighting_Normal_FS[ 2 ][ 10 ][ ANDROID_RENDER_TYPE_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// WRc`p̒_PʃCeBOVF[_[
	// VhE}bv̗L( 0: 1:L )
	// _VF[_[[ tHO^Cv ]
	// _VF[_[[ CgCfbNX ]
	// tOgVF[_[[ CgCfbNX ]
	// tOgVF[_[[ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// tOgVF[_[[ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_ANDROID_SHADER		*Base3D_VertexLighting_Normal_Shader[ 2 ][ 4 ][ 20 ][ 10 ][ ANDROID_RENDER_TYPE_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;
} ;


#ifndef DX_NON_MODEL

// Android ̃f`p̃VF[_[Z߂\
struct GRAPHICS_HARDWARE_ANDROID_SHADER_MODEL
{
	// f`psNZPʃCeBO^Cv̒_VF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	GLuint		MV1_PixelLighting_VS[ 2 ][ 3 ][ 2 ][ 4 ] ;


	// f`psNZPʃCeBO^CṽgD[^CvPptOgVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ LȃCg̐ - 1 ]
	// [ tOgVF[_[̃At@eXg[h ]
	GLuint		MV1_PixelLighting_ToonType1_FS[ 2 ][ 2 ][ 2 ][ 2 ][ DX_ANDR_COMMON_CONST_LIGHT_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// f`psNZPʃCeBO^CṽgD[^CvPpVF[_[( Xg͔z̍ )
	// VhE}bv̗L( 0: 1:L )
	// ov}bv̗L( 0: 1:L )
	// _VF[_[[ bV^Cv( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ]
	// _VF[_[[ tHO^Cv ]
	// tOgVF[_[[ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// tOgVF[_[[ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// tOgVF[_[[ LȃCg̐ - 1 ]
	// tOgVF[_[[ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_ANDROID_SHADER		*MV1_PixelLighting_ToonType1_Shader[ 2 ][ 2 ][ 3 ][ 4 ][ 2 ][ 2 ][ DX_ANDR_COMMON_CONST_LIGHT_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;



	// f`psNZPʃCeBO^CṽgD[^CvQptOgVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ LȃCg̐ - 1 ]
	// [ tOgVF[_[̃At@eXg[h ]
	GLuint		MV1_PixelLighting_ToonType2_FS[ 2 ][ 3 ][ DX_ANDR_COMMON_CONST_LIGHT_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// f`psNZPʃCeBO^CṽgD[^CvQpVF[_[( Xg͔z̍ )
	// VhE}bv̗L( 0: 1:L )
	// _VF[_[[ bV^Cv( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ]
	// _VF[_[[ ov}bv̗L( 0: 1:L ) ]
	// _VF[_[[ tHO^Cv ]
	// tOgVF[_[[ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// tOgVF[_[[ LȃCg̐ - 1 ]
	// tOgVF[_[[ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_ANDROID_SHADER		*MV1_PixelLighting_ToonType2_Shader[ 2 ][ 3 ][ 2 ][ 4 ][ 3 ][ DX_ANDR_COMMON_CONST_LIGHT_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;



	// f`psNZPʃCeBO^CṽtOgVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ LȃCg̐ - 1 ]
	// [ tOgVF[_[̃At@eXg[h ]
	GLuint		MV1_PixelLighting_Normal_FS[ 2 ][ 5 ][ 2 ][ DX_ANDR_COMMON_CONST_LIGHT_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// f`psNZPʃCeBO^CṽVF[_[( Xg͔z̍ )
	// VhE}bv̗L( 0: 1:L )
	// ov}bv̗L( 0: 1:L )
	// _VF[_[[ bV^Cv( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ]
	// _VF[_[[ tHO^Cv ]
	// tOgVF[_[[ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// tOgVF[_[[ LȃCg̐ - 1 ]
	// tOgVF[_[[ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_ANDROID_SHADER		*MV1_PixelLighting_Normal_Shader[ 2 ][ 2 ][ 3 ][ 4 ][ 5 ][ DX_ANDR_COMMON_CONST_LIGHT_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;






	// f`p̃}eAvf`ptOgVF[_[
	// }eA^Cv( DX_MATERIAL_TYPE_MAT_SPEC_LUMINANCE_UNORM Ȃ )
	// tOgVF[_[̃At@eXg[h
	GLuint		MV1_MaterialType_FS[ DX_MATERIAL_TYPE_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// f`p̃}eAvf`pVF[_[
	// MV1_NoLighting_VS + MV1_MaterialType_FS
	// _VF[_[[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// _VF[_[[ ov}bv̗L( 0: 1:L ) ]
	// tOgVF[_[[ }eA^Cv( DX_MATERIAL_TYPE_MAT_SPEC_LUMINANCE_UNORM Ȃ ) ]
	// tOgVF[_[[ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_ANDROID_SHADER		*MV1_MaterialType_Shader[ 3 ][ 2 ][ DX_MATERIAL_TYPE_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;




	// f`p̃VhE}bvւ̃gD[_O֊s`p_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	GLuint		MV1_ToonOutLine_ShadowMap_VS[ 3 ][ 2 ] ;

	// f`p̃VhE}bvւ̃_OpVF[_[
	// MV1_ToonOutLine_ShadowMap_VS + MV1_ShadowMap_Normal_FS
	// _VF[_[[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// _VF[_[[ ov}bv̗L( 0: 1:L ) ]
	// tOgVF[_[[ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_ANDROID_SHADER		*MV1_ToonOutLine_ShadowMap_Shader[ 3 ][ 2 ][ ANDROID_FS_ALPHATEST_NUM ] ;



	// f`p̃gD[_O̗֊s`p_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	GLuint		MV1_ToonOutLine_VS[ 3 ][ 2 ][ 4 ] ;

	// f`p̃CeBOȂVF[_[
	// MV1_ToonOutLine_VS + MV1_NoLighting_Normal_FS[ 0 ]
	// _VF[_[[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// _VF[_[[ ov}bv̗L( 0: 1:L ) ]
	// _VF[_[[ tHO^Cv ]
	// tOgVF[_[[ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_ANDROID_SHADER		*MV1_ToonOutLine_Shader[ 3 ][ 2 ][ 4 ][ ANDROID_FS_ALPHATEST_NUM ] ;




	// f`p̃VhE}bvւ̃_Op_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	GLuint		MV1_ShadowMap_VS[ 3 ][ 2 ] ;


	// f`p̃VhE}bvւ̃_OptOgVF[_[
	// [ tOgVF[_[̃At@eXg[h ]
	GLuint		MV1_ShadowMap_Normal_FS[ ANDROID_FS_ALPHATEST_NUM ] ;

	// f`p̃VhE}bvւ̃_OpVF[_[
	// MV1_ShadowMap_VS + MV1_ShadowMap_Normal_FS
	// _VF[_[[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// _VF[_[[ ov}bv̗L( 0: 1:L ) ]
	// tOgVF[_[[ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_ANDROID_SHADER		*MV1_ShadowMap_Normal_Shader[ 3 ][ 2 ][ ANDROID_FS_ALPHATEST_NUM ] ;



	// f`p̃VhE}bvւ̃gD[_OptOgVF[_[
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ tOgVF[_[̃At@eXg[h ]
	GLuint		MV1_ShadowMap_Toon_FS[ 2 ][ 3 ][ 2 ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// f`p̃VhE}bvւ̃gD[_OpVF[_[
	// MV1_ShadowMap_VS + MV1_ShadowMap_Toon_FS
	// _VF[_[[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// _VF[_[[ ov}bv̗L( 0: 1:L ) ]
	// tOgVF[_[[ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// tOgVF[_[[ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// tOgVF[_[[ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// tOgVF[_[[ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_ANDROID_SHADER		*MV1_ShadowMap_Toon_Shader[ 3 ][ 2 ][ 2 ][ 3 ][ 2 ][ ANDROID_FS_ALPHATEST_NUM ] ;



	// f`p̃CeBOȂ_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	GLuint		MV1_NoLighting_VS[ 3 ][ 2 ][ 4 ] ;


	// f`p̃CeBOȂgD[ptOgVF[_[( Xg͔z̍ )
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT or gD[_Oł͂Ȃ  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ tOgVF[_[̃At@eXg[h ]
	GLuint		MV1_NoLighting_Toon_FS[ 2 ][ 2 ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// f`p̃CeBOȂgD[pVF[_[( Xg͔z̍ )
	// MV1_NoLighting_VS + MV1_NoLighting_Toon_FS
	// _VF[_[[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// _VF[_[[ ov}bv̗L( 0: 1:L ) ]
	// _VF[_[[ tHO^Cv ]
	// tOgVF[_[[ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// tOgVF[_[[ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT or gD[_Oł͂Ȃ  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// tOgVF[_[[ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_ANDROID_SHADER		*MV1_NoLighting_Toon_Shader[ 3 ][ 2 ][ 4 ][ 2 ][ 2 ][ ANDROID_FS_ALPHATEST_NUM ] ;



	// f`p̃CeBOȂtOgVF[_[
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ tOgVF[_[̃At@eXg[h ]
	GLuint		MV1_NoLighting_Normal_FS[ 5 ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// f`p̃CeBOȂVF[_[
	// MV1_NoLighting_VS + MV1_NoLighting_Normal_FS
	// _VF[_[[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// _VF[_[[ ov}bv̗L( 0: 1:L ) ]
	// _VF[_[[ tHO^Cv ]
	// tOgVF[_[[ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// tOgVF[_[[ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_ANDROID_SHADER		*MV1_NoLighting_Normal_Shader[ 3 ][ 2 ][ 4 ][ 5 ][ ANDROID_FS_ALPHATEST_NUM ] ;



	// f`p̒_PʃCeBO蒸_VF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	// [ CgCfbNX ]
	GLuint		MV1_VertexLighting_VS[ 2 ][ 3 ][ 2 ][ 4 ][ 20 ] ;


	// f`p̒_PʃCeBOgD[^CvPptOgVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ tOgVF[_[̃At@eXg[h ]
	GLuint		MV1_VertexLighting_ToonType1_FS[ 2 ][ 2 ][ 2 ][ 2 ][ 10 ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// f`p̒_PʃCeBOgD[^CvPpVF[_[
	// VhE}bv̗L( 0: 1:L )
	// ov}bv̗L( 0: 1:L )
	// _VF[_[[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// _VF[_[[ tHO^Cv ]
	// _VF[_[[ CgCfbNX ]
	// tOgVF[_[[ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// tOgVF[_[[ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// tOgVF[_[[ CgCfbNX ]
	// tOgVF[_[[ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_ANDROID_SHADER		*MV1_VertexLighting_ToonType1_Shader[ 2 ][ 2 ][ 3 ][ 4 ][ 20 ][ 2 ][ 2 ][ 10 ][ ANDROID_FS_ALPHATEST_NUM ] ;



	// f`p̒_PʃCeBOgD[^CvQptOgVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ CgCfbNX ]
	// [ tOgVF[_[̃At@eXg[h ]
	GLuint		MV1_VertexLighting_ToonType2_FS[ 2 ][ 3 ][ 10 ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// f`p̒_PʃCeBOgD[^CvQpVF[_[
	// VhE}bv̗L( 0: 1:L )
	// _VF[_[[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// _VF[_[[ ov}bv̗L( 0: 1:L ) ]
	// _VF[_[[ tHO^Cv ]
	// _VF[_[[ CgCfbNX ]
	// tOgVF[_[[ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// tOgVF[_[[ CgCfbNX ]
	// tOgVF[_[[ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_ANDROID_SHADER		*MV1_VertexLighting_ToonType2_Shader[ 2 ][ 3 ][ 2 ][ 4 ][ 20 ][ 3 ][ 10 ][ ANDROID_FS_ALPHATEST_NUM ] ;



	// f`p̒_PʃCeBOtOgVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ tOgVF[_[̃At@eXg[h ]
	GLuint		MV1_VertexLighting_Normal_FS[ 2 ][ 5 ][ 2 ][ 10 ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// f`p̒_PʃCeBOVF[_[
	// VhE}bv̗L( 0: 1:L )
	// ov}bv̗L( 0: 1:L )
	// _VF[_[[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// _VF[_[[ tHO^Cv ]
	// _VF[_[[ CgCfbNX ]
	// tOgVF[_[[ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// tOgVF[_[[ CgCfbNX ]
	// tOgVF[_[[ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_ANDROID_SHADER		*MV1_VertexLighting_Normal_Shader[ 2 ][ 2 ][ 3 ][ 4 ][ 20 ][ 5 ][ 10 ][ ANDROID_FS_ALPHATEST_NUM ] ;
} ;
#endif // DX_NON_MODEL

// Android ̒萔Z߂\
struct GRAPHICS_HARDWARE_ANDROID_CONSTANT
{
	// _VF[_[AtOgVF[_[
	DX_ANDR_SHADER_FLOAT4			uAmb_Emi ;									// G~bVuJ[{ArGgJ[( G~bVuJ[ + }eAArGgJ[ * O[oArGgJ[ )

	DX_ANDR_SHADER_FLOAT4			uMatDif ;									// fBt[YJ[
	DX_ANDR_SHADER_FLOAT4			uMatSpc ;									// XyLJ[
	DX_ANDR_SHADER_FLOAT			uMatPow ;									// XyL̋
	DX_ANDR_SHADER_FLOAT			uMatTypeParam0 ;							// ^Cvp[^0
	DX_ANDR_SHADER_FLOAT			uMatTypeParam1 ;							// ^Cvp[^1
	DX_ANDR_SHADER_FLOAT			uMatTypeParam2 ;							// ^Cvp[^2

	DX_ANDR_SHADER_FLOAT3			uLightPos[ 6 /* _VF[_[Ŏgp̂ 3 */ ] ;					// W( r[ )
	DX_ANDR_SHADER_FLOAT3			uLightDir[ 6 /* _VF[_[Ŏgp̂ 3 */ ] ;					// ( r[ )
	DX_ANDR_SHADER_FLOAT4			uLightDif[ 6 /* _VF[_[Ŏgp̂ 3 */ ] ;					// fBt[YJ[
	DX_ANDR_SHADER_FLOAT4			uLightSpc[ 6 /* _VF[_[Ŏgp̂ 3 */ ] ;					// XyLJ[
	DX_ANDR_SHADER_FLOAT4			uLightAmb[ 6 /* _VF[_[Ŏgp̂ 3 */ ] ;					// ArGgJ[
	DX_ANDR_SHADER_FLOAT4			uLightRange_FallOff_AT0_AT1[ 6 /* _VF[_[Ŏgp̂ 3 */ ] ;	// x:L  y:X|bgCgpFllOff  z:ɂ錸pp[^O  w:ɂ錸pp[^P
	DX_ANDR_SHADER_FLOAT4			uLightAT2_SpotP0_SpotP1[ 6 /* _VF[_[Ŏgp̂ 3 */ ] ;		// x:ɂ錸pp[^Q  y:X|bgCgpp[^O( cos( Phi / 2.0 ) )  z:X|bgCgpp[^P( 1.0 / ( cos( Theta / 2.0 ) - cos( Phi / 2.0 ) ) )


	// _VF[_[p
	DX_ANDR_SHADER_FLOAT4			uAntiVPMat[ 4 ] ;							// r[|[gšʂłs
	DX_ANDR_SHADER_FLOAT4			uViewMat[ 3 ] ;								// [h@@r[s
	DX_ANDR_SHADER_FLOAT4			uProjMat[ 4 ] ;								// r[@@vWFNVs
	DX_ANDR_SHADER_FLOAT4			uFog ;										// tHOpp[^( x:end/(end - start)  y:-1/(end - start)  z:density  w:Rΐ̒ )

	DX_ANDR_SHADER_FLOAT4			uToonOutLineSize ;							// gD[̗֊s̑傫
	DX_ANDR_SHADER_FLOAT4			uDifSrc_SpeSrc_MulSpeCol ;					// x:fBt[YJ[( 0.0:}eA  1.0:_ )  y:XyLJ[(   0.0:}eA  1.0:_ )  z:XyLJ[lɏZl( XyLŎgp )

	DX_ANDR_SHADER_FLOAT4			uSMLVPMat[ 12 /* [ 3 ][ 4 ] */ ] ;	// VhE}bvp̃Cgr[sƃCgˉesZ

	DX_ANDR_SHADER_FLOAT4			uTexMat[ 6 /* [ DX_VS_CONSTF_TEXTURE_MATRIX_NUM ][ 2 ] */ ] ;	// eNX`Wps
	DX_ANDR_SHADER_FLOAT4			uLWMat[ 162 /* DX_VS_CONSTF_WORLD_MAT_NUM * 3 */ ] ;		// [J@@[hs


	// tOgVF[_[p
	DX_ANDR_SHADER_FLOAT			uMulAlphaColor ;							// J[ɃAt@lZ邩ǂ( 0.0:ZȂ  1.0:Z )

	DX_ANDR_SHADER_FLOAT			uATestRef ;									// eXgl
	DX_ANDR_SHADER_INT				uATestCmpMode ;

	DX_ANDR_SHADER_FLOAT4			uFogColor ;									// tHOJ[
	DX_ANDR_SHADER_FLOAT4			uFactorColor ;								// t@N^[J[
	DX_ANDR_SHADER_FLOAT4			uIgnoreTextureColor ;						// eNX`J[pJ[

	DX_ANDR_SHADER_FLOAT4			uShadowMapLightEnable[ 6 ] ;				// VhE}bvOEPEQ̃CgL( x:VhE}bvOŃCgnL  y:VhE}bvPŃCgnL  z:VhE}bvQŃCgnL )
	DX_ANDR_SHADER_FLOAT2			uShadowMap_DAdj_Grad[ 3 ] ;					// VhE}bv̏( x:臒l[x␳l  y:Of[V͈  )

	int								UpdateCount ;								// 萔̓eύXꂽ

	int								SetNormalMaterial ;							// 萔obt@ɕW`p̃}eAp[^ݒ肳Ă邩ǂ( TRUE:ݒ肳Ă  FALSE:ݒ肳ĂȂ )
	int								SetNormalColorSource ;						// 萔obt@ɕW`ṕufBt[YJ[EXyLJ[}eAgp邩A_f[^gp邩v̐ݒ肪Ă邩ǂ( TRUE:ݒ肳Ă  FALSE:ݒ肳ĂȂ )
	int								SetNormalTextureAddressTransformMatrix ;	// 萔obt@ɕW`p̃eNX`Wps񂪐ݒ肳Ă邩ǂ( TRUE:ݒ肳Ă  FALSE:ݒ肳ĂȂ )
} ;

// VF[_[񃊃Xg\
struct GRAPHICS_ANDROID_SHADER_LIST
{
	int								UseNum ;									// Shaders ŎgpĂz̐
	GRAPHICS_ANDROID_SHADER			Shaders[ SHADERS_LIST_DATA_NUM ] ;			// VF[_[
	GRAPHICS_ANDROID_SHADER_LIST	*Next ;										// ̃VF[_[Xg
} ;

// Android ̃VF[_[Z߂\
struct GRAPHICS_HARDWARE_ANDROID_SHADER
{
	GRAPHICS_HARDWARE_ANDROID_CONSTANT				Constant ;						// 萔Z߂\

	GRAPHICS_ANDROID_SHADER_LIST					*ShadersListFirst ;				// VF[_[񃊃Xg([)
	GRAPHICS_ANDROID_SHADER_LIST					*ShadersListLast ;				// VF[_[񃊃Xg([)

	GRAPHICS_HARDWARE_ANDROID_SHADER_BASE			Base ;							// W`揈p̃VF[_[Z߂\
	GRAPHICS_HARDWARE_ANDROID_SHADER_BASE3D			Base3D ;						// WRc`揈p̃VF[_[Z߂\

#ifndef DX_NON_MODEL
	GRAPHICS_HARDWARE_ANDROID_SHADER_MODEL			Model ;							// f`揈p̃VF[_[Z߂\
#endif // DX_NON_MODEL
} ;









// AndroidDevice ɐݒ肵ĂlZ߂\
struct GRAPHICS_HARDDATA_ANDROID_DEVICE_STATE
{
	int								FogEnable ;										// tHOLǂ( TRUE:L  FALSE: )
	int								FogMode ;										// tHO[h
	DWORD							FogColor ;										// tHOJ[
	float							FogStart ;										// tHOJn
	float							FogEnd ;										// tHOI
	float							FogDensity ;									// tHOx

	COLOR_U8						BackgroundColor ;								// wiF

	COLOR_F							GlobalAmbientLightColor ;						// O[oArGgCgJ[
	int								LightEnableMaxIndex ;							// LȃCg̍őCfbNX
	int								LightEnableFlag[ DX_ANDR_COMMON_CONST_LIGHT_NUM ] ;// CgLǂtO( TRUE:L  FALSE: )
	LIGHTPARAM						LightParam[ DX_ANDR_COMMON_CONST_LIGHT_NUM ] ;	// Cg̃p[^
	int								Lighting ;										// CeBOsǂ̃tO( TRUE:CeBOs  FALSE:CeBOȂ )

	int								UseSpecular ;									// XyLgp邩ǂ
	MATERIALPARAM					Material ;										// }eA
	float							MaterialTypeParam[ MATERIAL_TYPEPARAM_MAX_NUM ] ;	// }eAʃ^Cvp[^
	int								MaterialUseVertexDiffuseColor ;					// _̃fBt[YJ[}eÃfBt[YJ[ƂĎgp邩ǂ
	int								MaterialUseVertexSpecularColor ;				// _̃XyLJ[}eÃXyLJ[ƂĎgp邩ǂ

	int								DrawMode ;										// `惂[h( DX_DRAWMODE_BILINEAR Ȃ )AW̃tB^O[hł͂Ȃꍇ -1
	int								MaxAnisotropy ;									// őٕASẴTvɑ΂ēݒ肪sĂȂꍇ -1
	int								MaxAnisotropyDim[ USE_TEXTURESTAGE_NUM ] ;		// eTv̍őٕ
	GLint							TexMagFilter[ USE_TEXTURESTAGE_NUM ] ;			// gtB^[( GL_TEXTURE_MAG_FILTER ̃p[^A GL_NEAREST Ȃ )
	GLint							TexMinFilter[ USE_TEXTURESTAGE_NUM ] ;			// ktB^[( GL_TEXTURE_MIN_FILTER ̃p[^A GL_NEAREST Ȃ )
	GLint							TexAddressModeU[ USE_TEXTURESTAGE_NUM ] ;		// eNX`AhX[ht( GL_TEXTURE_WRAP_S ̃p[^A GL_REPEAT Ȃ )
	GLint							TexAddressModeV[ USE_TEXTURESTAGE_NUM ] ;		// eNX`AhX[hu( GL_TEXTURE_WRAP_T ̃p[^A GL_REPEAT Ȃ )
	GLint							TexAddressModeW[ USE_TEXTURESTAGE_NUM ] ;		// eNX`AhX[hv( GL_TEXTURE_WRAP_R ̃p[^A GL_REPEAT Ȃ )

	RECT							ViewportRect ;									// r[|[g̋`

	int								CullEnable ;									// JOsǂ
	GLenum							CullFace ;										// JO( GL_BACK Ȃ )
	int								DepthBias ;										// [xloCAX

	int								DepthEnable ;									// [xobt@̗LtO( [xobt@LA glEnable( GL_DEPTH_TEST ), glDisable( GL_DEPTH_TEST ) ōs )
	int								DepthWriteEnable ;								// [xobt@ւ݂̏Lǂ( ݂sǂ̐ݒ glDepthMask ōs )
	GLenum							DepthFunc ;										// [xl̔r[h( GL_LEQUAL Ȃ )

	int								BlendMode ;										// ݃foCXɐݒ肳Ăuh[hAvZbg̃uh[hȊȌꍇ -1 
	int								NotWriteAlphaChannelFlag ;						// At@`l̓eȂǂ̃tO

	GRAPHICS_ANDROID_TEXTURE		*SetTexture[ USE_TEXTURESTAGE_NUM ] ;			// `掞ɎgpeNX`

	RECT							ScissorRect ;									// VU[`
	int								AlphaTestEnable ;								// At@eXggp邩ǂ
	int								AlphaTestCmpMode ;								// At@eXgŎgpr[h( DX_CMP_NEVER Ȃ )
	int								AlphaTestRef ;									// At@eXgŎgpQƒl
	int								AlphaTestModeShaderIndex ;						// At@eXg̐ݒlɑΉtOgVF[_[̃At@eXg[h( ANDROID_FS_ALPHATEST_CMP_GREATER Ȃ )

	int								SetNormalShader ;								// ʏ`pVF[_[ZbgĂ邩ǂ
	GRAPHICS_ANDROID_SHADER	*		SetShader ;										// ݃ZbgĂVF[_[
	GRAPHICS_ANDROID_SHADER	*		SetShader_Force ;								// NULL ȊȌꍇDIɎgpVF[_[( ꏈp )

	GLuint							SetVertexBuffer ;								// ݃ZbgĂ钸_obt@
	int								VertexAttrEnable[ ANDROID_VERTEX_ATTR_NUM ] ;	// LɂȂĂ钸_f[^

	GLuint							TargetFrameBuffer ;								// `Ώۂ̃t[obt@
	GLuint							TargetFrameBufferWidth ;						// `Ώۂ̃t[obt@̕
	GLuint							TargetFrameBufferHeight ;						// `Ώۂ̃t[obt@̍

	int								TextureAddressTransformMatrixUse ;				// eNX`Wϊsgp邩ǂ( TRUE:gp  FALSE:gpȂ )
	MATRIX							TextureAddressTransformMatrix ;					// eNX`Wϊs
} ;


// AndroidDevice ̕`揈Ɋւ̍\
struct GRAPHICS_HARDDATA_ANDROID_DRAWINFO
{
	BYTE *						VertexBufferNextAddr ;						// ̃f[^i[ׂ_obt@̃AhX
	BYTE						VertexBuffer[ DX_GLES2_VERTBUFFERSIZE ] ;	// _obt@
	int							Use3DVertex ;							// Rc_gpĂ邩ǂ( 1:gpĂ  0:gpĂȂ )
	int							VertexNum ; 							// _obt@Ɋi[Ă钸_̐
	int							VertexType ;							// _obt@Ɋi[Ă钸_f[^( VERTEXTYPE_TEX Ȃ )
	GLenum						PrimitiveType ;							// _obt@Ɋi[Ă钸_f[^̃v~eBu^Cv

	DWORD						DiffuseColor ;							// fBt[YJ[

	int							BeginSceneFlag ;						// Graphics_Android_BeginScene sĂ邩ǂ
	int							BlendMaxNotDrawFlag ;					// uhlőł邱Ƃɂ`sȂǂAtO
} ;

// AndroidDevice ̉ʊ֌W̏̍\
struct GRAPHICS_HARDDATA_ANDROID_SCREENINFO
{
	EGLDisplay					Display ;								// o͐ EGLDisplay
	EGLSurface					Surface ;								// o͐̃fBXvC EGLSurface
	EGLContext					Context ;								// o͐̃fBXvC EGLContext
	EGLint						Width ;									// o͐T[tFX̕
	EGLint						Height ;								// o͐T[tFX̍

	int							FrontScreenCopyTime ;					// \ʂ`ƂĂꍇɍs ScreenCopy s

	int							SubBackBufferTextureSizeX ;				// TuobNobt@eNX`̉
	int							SubBackBufferTextureSizeY ;				// TuobNobt@eNX`̏c
	GLuint						SubBackBufferTextureInternalFormat ;	// TuobNobt@eNX`̓tH[}bg
	GLenum						SubBackBufferTexturePixelFormat ;		// TuobNobt@eNX`̃sNZtH[}bg
	GLuint						SubBackBufferTexturePixelType ;			// TuobNobt@eNX`̃sNZ^Cv
	void *						SubBackBufferTextureTempBuffer ;		// TuobNobt@eNX`ɃC[W]ۂɎgpobt@
	GLuint						SubBackBufferFrameBuffer ;				// ScreenCopy  GetDrawScreen 邽߂Ɏgpt[obt@
	GLuint						SubBackBufferTexture ;					// ScreenCopy  GetDrawScreen 邽߂ɎgpeNX`obt@
	GLuint						SubBackBufferDepthBuffer ;				// ScreenCopy  GetDrawScreen 邽߂Ɏgp[xobt@

	void *						DrawScreenLockImage ;					// `̃bNɍ쐬e|C[W
	GLuint						DrawScreenLockImagePitch ;				// bNC[W̃sb`
} ;


// AndroidDevice ̕`ݒɊւ̍\
struct GRAPHICS_HARDDATA_ANDROID_DRAWSETTING
{
	int								DrawPrepParamFlag ;						// O Graphics_Android_DrawPreparation ɓƂ ParamFlag p[^
	int								DrawPrepAlwaysFlag ;					// K Graphics_Android_DrawPreparation sǂ̃tO

	int								AlphaChannelValidFlag ;					// `lLtO
	int								AlphaTestValidFlag ;					// eXgLtO( Func ͕K D_D3DCMP_GREATEREQUAL )
	int								AlphaTestMode ;							// At@eXg[h
	int								AlphaTestParam ;						// At@eXgp[^
	int								BlendMode ;								// uh[h
	int								ChangeBlendParamFlag ;					// uhݒɊւ镔̕ύXAtO
	int								ChangeTextureFlag ;						// eNX`ύXꂽAtO
	int								NotWriteAlphaChannelFlag ;				// At@`l̓eȂǂ̃tO
	int								IgnoreGraphColorFlag ;					// `悷摜̂qfa𖳎邩ǂ̃tO
	int								IgnoreGraphAlphaFlag ;					// `悷摜̂`𖳎邩ǂ̃tO
//	int								UseDiffuseRGBColor ;					// fBt[YJ[̂qfalgp邩AtO
//	int								UseDiffuseAlphaColor ;					// fBt[YJ[̃lgp邩AtO
	int								BlendGraphType ;						// uh摜^Cv
	int								BlendGraphFadeRatio ;					// uh摜̃tF[hp[^
	int								BlendGraphBorderParam ;					// uh摜̋Ep[^(O(uh摜̉eO)@@(uh摜̉eȂ)@@PQW(uh摜̉ePOO)@@(uh摜̉e𒴂Ĕ`敔)@QTT(S`悳Ȃ) )
	int								BlendGraphBorderRange ;					// uh摜̋E(O`QTT@`L@SiK)
	float							BlendTextureWidth ;						// uheNX`̕
	float							BlendTextureHeight ;					// uheNX`̍
	float							InvBlendTextureWidth ;					// uheNX`̋̕t
	float							InvBlendTextureHeight ;					// uheNX`̍̋t

	GRAPHICS_ANDROID_TEXTURE		*RenderTexture ;						// `掞ɎgpeNX`[
	GRAPHICS_ANDROID_TEXTURE		*BlendTexture ;							// `掞ɕ`eNX`[ƃuh郿`leNX`[

	int								CancelSettingEqualCheck ;				// ̃tOĂꍇ݂͌̐ݒƕύX̐ݒ肪ǂɊւ炸AKύXs
} ;


// AndroidDevice ֌W̐ݒ̍\
struct GRAPHICS_HARDDATA_ANDROID_DEVICE_SETTING
{
	void					( *DeviceRestoreCallbackFunction)( void *Data ) ;	// foCXXg畜AƂɌĂԊ֐
	void					  *DeviceRestoreCallbackData ;						// foCXXg畜AƂɌĂԊ֐ɓn|C^

	void					( *DeviceLostCallbackFunction)( void *Data ) ;		// foCXXg畜AOɌĂԊ֐
	void					  *DeviceLostCallbackData ;							// foCXXg畜AOɌĂԊ֐ɓn|C^
} ;


// AndroidDevice ̔\͏\
struct GRAPHICS_HARDDATA_ANDROID_DEVICE_CAPS
{
	TCHAR *						Version ;
	TCHAR *						Renderer ;
	TCHAR *						Vendor ;

	unsigned char				Extensions[ ANDROID_GL_EXTENSION_NUM ] ;			// Extensions
	int							ExtensionNum ;										// Extension ̐
	TCHAR **					ExtensionNames ;									// Extension ̔z

	TCHAR *						Shading_Language_Version ;

	GLint						Shader_Max_Vertex_Attribs ;							// GL_MAX_VERTEX_ATTRIBS
	GLint						Shader_Max_Vertex_Uniform_Vectors ;					// GL_MAX_VERTEX_UNIFORM_VECTORS
	GLint						Shader_Max_Varying_Vectors ;						// GL_MAX_VARYING_VECTORS
	GLint						Shader_Max_Combined_Texture_Image_Units ;			// GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS
	GLint						Shader_Max_Vertex_Texture_Image_Units ;				// GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS
	GLint						Shader_Max_Texture_Image_Units ;					// GL_MAX_TEXTURE_IMAGE_UNITS
	GLint						Shader_Max_Fragment_Uniform_Vectors ;				// GL_MAX_FRAGMENT_UNIFORM_VECTORS

	int							ScreenFormat ;										// ʃJ[tH[}bg
	int							TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_NUM ] ;	// eNX`tH[}bg
	int							MaskAlphaFormat ;									// }XNAt@`lptH[}bg
	GLenum						DepthBufferFormat[ ZBUFFER_FORMAT_NUM ] ;			// [xobt@tH[}bg
} ;


// Android g`揈Ŏgpf[^̓ AndroidDevice ̃Zbg
// KvAAndroidDevice ɖڂɊւZ߂\
struct GRAPHICS_HARDDATA_ANDROID_DEVICE
{
	GRAPHICS_HARDDATA_ANDROID_DEVICE_CAPS			Caps ;					// foCX\͏\		

	GRAPHICS_HARDDATA_ANDROID_DEVICE_SETTING		Setting ;				// foCX֌W̐ݒZ߂\

	GRAPHICS_HARDDATA_ANDROID_SCREENINFO			Screen ;				// ʊ֌W̏\

	GRAPHICS_HARDWARE_ANDROID_SHADER				Shader ;				// VF[_[Z߂\

//	GRAPHICS_HARDWARE_ANDROID_INPUTLAYOUT			InputLayout ;			// ̓CAEgZ߂\

	GRAPHICS_HARDDATA_ANDROID_DRAWSETTING			DrawSetting ;			// `ݒɊւZ߂\

	GRAPHICS_HARDDATA_ANDROID_DRAWINFO				DrawInfo ;				// `揈ɊւZ߂\

	GRAPHICS_HARDDATA_ANDROID_DEVICE_STATE			State ;					// AndroidDevice ɐݒ肵ĂlZ߂\
} ;













// VF[_[R[h̏\
struct GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO
{
	void					*Binary ;								// VF[_[R[hoCĩAhX
	int						Size ;									// VF[_[R[hoCĩf[^TCY
} ;


// Android  W`p̃VF[_[R[ȟf[^Z߂\
struct GRAPHICS_HARDWARE_ANDROID_SHADERCODE_BASE
{
	int						BaseShaderInitializeFlag ;				// VF[_[oCĩZbgAbvĂ邩ǂ̃tO( TRUE:Ă  FALSE:ĂȂ )

	// CgCfbNXXg
	short					LightIndexList84[ 4 ][ 4 ][ 4 ][ 4 ][ 4 ][ 4 ] ;
	short					LightIndexList20[ 4 ][ 4 ][ 4 ] ;
	short					LightIndexList10[ 3 ][ 3 ][ 3 ] ;

	void					*Base2DShaderPackageImage ;				// WQc`pVF[_[pbP[WoCiC[W

	// W`p̕GȏsȂ_VF[_[
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO BaseSimple_VS_Code[ ANDROID_VERTEX_INPUTLAYOUT_NUM ] ;

	// Œ@\pCvC݊̃tOgVF[_[( eNX`Ȃ )
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO BaseNoneTex_FS_Code[ ANDROID_RENDER_TYPE_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// Œ@\pCvC݊̃tOgVF[_[( eNX` )
	// [ uh摜Ƃ̃uh^Cv( 0:Ȃ  1:DX_BLENDGRAPHTYPE_NORMAL  2:DX_BLENDGRAPHTYPE_WIPE  3:DX_BLENDGRAPHTYPE_ALPHA ) ]
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ eNX`RGB( 0:Ȃ  1: ) ]
	// [ eNX`Alpha( 0:Ȃ  1: ) ]
	// [ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO BaseUseTex_FS_Code[ 4 ][ ANDROID_RENDER_TYPE_NUM ][ 2 ][ 2 ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// }XNpVF[_[
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MaskEffect_VS_Code ;
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MaskEffect_FS_Code ;
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MaskEffect_ReverseEffect_FS_Code ;
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MaskEffect_UseGraphHandle_FS_Code[ 4 ] ;
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MaskEffect_UseGraphHandle_ReverseEffect_FS_Code[ 4 ] ;

	// P]pVF[_[
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO StretchRect_VS_Code ;
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO StretchRectTex2_VS_Code ;
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO StretchRectTex8_VS_Code ;
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO StretchRect_FS_Code ;

	// NApVF[_[
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO ClearRT_VS_Code ;
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO ClearRT_FS_Code ;

#ifndef DX_NON_FILTER
	DXARC					FilterShaderBinDxa ;					// tB^[VF[_[IuWFNgt@Ccw`\
	void					*FilterShaderBinDxaImage ;				// tB^[VF[_[IuWFNgt@Ccw`̃oCiC[W

	void					*RGBAMixS_ShaderPackImage ;				// RGBAMix  S ̑gݍ킹QTU̃VF[_[pbP[WoCiC[W

	// RGBAMix  S ̑gݍ킹QTU̃VF[_[[ R ][ G ][ B ][ A ][ 0:ʏp  1:Zς݃At@p ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO RGBAMixS_FS_Code[ 4 ][ 4 ][ 4 ][ 4 ][ 2 ] ;
#endif // DX_NON_FILTER
} ;

// Android  WRc`p̃VF[_[R[ȟf[^Z߂\
struct GRAPHICS_HARDWARE_ANDROID_SHADERCODE_BASE3D
{
	volatile int			Base3DShaderInitializeFlag ;			// VF[_[oCĩZbgAbvĂ邩ǂ̃tO( TRUE:Ă  FALSE:ĂȂ )

	void					*Base3DShaderPackageImage ;				// WRc`pVF[_[pbP[WoCiC[W

	// WRc`psNZPʃCeBO^Cv̒_VF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// /* [ bV^Cv( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ] */
	// /* [ ov}bv̗L( 0: 1:L ) ] */
	// [ tHO^Cv ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO Base3D_PixelLighting_VS_Code[ 2 ]/*[ 3 ]*//*[ 2 ]*/[ 4 ] ;

	// WRc`psNZPʃCeBO^CṽtOgVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// /*[ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]*/
	// /*[ XyL}bv ( 0: 1: ) ]*/
	// /*[ ov}bv ( 0:Ȃ 1: ) ]*/
	// [ CgCfbNX ]
	// /*[ XyL̗L( 0: 1:L ) ]*/
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO Base3D_PixelLighting_Normal_FS_Code[ 2 ]/*[ 5 ]*//*[ 2 ]*//*[ 2 ]*/[ 84 ]/*[ 2 ]*/[ ANDROID_RENDER_TYPE_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;



	// WRc`p̃VhE}bvւ̃_Op_VF[_[
	// /*[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]*/
	// [ ov}bv̗L( 0: 1:L ) ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO Base3D_ShadowMap_VS_Code/*[ 3 ]*/[ 2 ] ;

	// WRc`p̃CeBOȂ_VF[_[
	// /*[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]*/
	// [ tHO^Cv ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO Base3D_NoLighting_VS_Code/*[ 3 ]*/[ 4 ] ;

	// WRc`p̒_PʃCeBO_VF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// /*[ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]*/
	// /*[ ov}bv̗L( 0: 1:L ) ]*/
	// [ tHO^Cv ]
	// [ CgCfbNX ]
	// /*[ XyL̗L( 0: 1:L ) ]*/
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO Base3D_VertexLighting_VS_Code[ 2 ]/*[ 3 ]*//*[ 2 ]*/[ 4 ][ 20 ]/*[ 2 ]*/ ;

	// WRc`p̃VhE}bvւ̃_OptOgVF[_[
	// [ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO Base3D_ShadowMap_Normal_FS_Code[ ANDROID_FS_ALPHATEST_NUM ] ;

	// WRc`p̃CeBOȂtOgVF[_[
	// /*[ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]*/
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO Base3D_NoLighting_Normal_FS_Code/*[ 5 ]*/[ ANDROID_RENDER_TYPE_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// WRc`p̒_PʃCeBOtOgVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// /* [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ] */
	// /* [ XyL}bv ( 0: 1: ) ] */
	// /* [ ov}bv ( 0:Ȃ 1: ) ] */
	// [ CgCfbNX ]
	// /*[ XyL̗L( 0: 1:L ) ]*/
	// [ ( 0:ʏ`  1:Z`  2:RGB]  3:`PxS{  4:Zς݃uh[h̒ʏ`  5:Zς݃uh[hRGB]  6:Zς݃uh[h̕`Px4{ ) ]
	// [ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO Base3D_VertexLighting_Normal_FS_Code[ 2 ]/*[ 5 ]*//*[ 2 ]*//*[ 2 ]*/[ 10 ]/*[ 2 ]*/[ ANDROID_RENDER_TYPE_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;
} ;

#ifndef DX_NON_MODEL

// Android  f`p̃VF[_[R[ȟf[^Z߂\
struct GRAPHICS_HARDWARE_ANDROID_SHADERCODE_MODEL
{
	volatile int			ModelShaderInitializeFlag ;				// fp̃VF[_[oCĩZbgAbvĂ邩ǂ̃tO( TRUE:Ă  FALSE:ĂȂ )

	void					*ModelShaderPackImage ;					// RcfpVF[_[pbP[WoCiC[W

	// f`psNZPʃCeBO^Cv̒_VF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV 2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MV1_PixelLighting_VS_Code[ 2 ][ 3 ][ 2 ][ 4 ] ;

	// f`psNZPʃCeBO^CṽgD[^CvPptOgVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ LȃCg̐ - 1 ]
	// [ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MV1_PixelLighting_ToonType1_FS_Code[ 2 ][ 2 ][ 2 ][ 2 ][ DX_ANDR_COMMON_CONST_LIGHT_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// f`psNZPʃCeBO^CṽgD[^CvQptOgVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ LȃCg̐ - 1 ]
	// [ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MV1_PixelLighting_ToonType2_FS_Code[ 2 ][ 3 ][ DX_ANDR_COMMON_CONST_LIGHT_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// f`psNZPʃCeBO^CṽtOgVF[_[( Xg͔z̍ )
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ LȃCg̐ - 1 ]
	// [ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MV1_PixelLighting_Normal_FS_Code[ 2 ][ 5 ][ 2 ][ DX_ANDR_COMMON_CONST_LIGHT_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;






	// f`p̃}eAvf`ptOgVF[_[
	// [ }eA^Cv( DX_MATERIAL_TYPE_MAT_SPEC_LUMINANCE_UNORM Ȃ ) ]
	// [ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MV1_MaterialType_FS_Code[ DX_MATERIAL_TYPE_NUM ][ ANDROID_FS_ALPHATEST_NUM ] ;






	// f`p̃VhE}bvւ̃gD[_O֊s`p_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MV1_ToonOutLine_ShadowMap_VS_Code[ 3 ][ 2 ] ;

	// f`p̃gD[_O̗֊s`p_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MV1_ToonOutLine_VS_Code[ 3 ][ 2 ][ 4 ] ;

	// f`p̃VhE}bvւ̃_Op_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MV1_ShadowMap_VS_Code[ 3 ][ 2 ] ;

	// f`p̃CeBOȂ_VF[_[
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MV1_NoLighting_VS_Code[ 3 ][ 2 ][ 4 ] ;

	// f`p̒_PʃCeBO蒸_VF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ bV^Cv( 0:̃bV 1:4{[XLjObV  2:8{[XLjObV ) ]
	// [ ov}bv̗L( 0: 1:L ) ]
	// [ tHO^Cv ]
	// [ CgCfbNX ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MV1_VertexLighting_VS_Code[ 2 ][ 3 ][ 2 ][ 4 ][ 20 ] ;

	// f`p̃VhE}bvւ̃gD[_OptOgVF[_[
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MV1_ShadowMap_Toon_FS_Code[ 2 ][ 3 ][ 2 ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// f`p̃VhE}bvւ̃_OptOgVF[_[
	// [ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MV1_ShadowMap_Normal_FS_Code[ ANDROID_FS_ALPHATEST_NUM ] ;

	// f`p̃CeBOȂgD[ptOgVF[_[( Xg͔z̍ )
	// [ gD[_O^Cv( 0:gD[_O type 1   1:gD[_O type 2 ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT or gD[_Oł͂Ȃ  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MV1_NoLighting_Toon_FS_Code[ 2 ][ 2 ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// f`p̃CeBOȂtOgVF[_[
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MV1_NoLighting_Normal_FS_Code[ 5 ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// f`p̒_PʃCeBOgD[^CvPptOgVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_ÕfBt[YOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_MODULATE ) ]
	// [ gD[_ÕXyLOf[Ṽuh^Cv( 0:MV1_LAYERBLEND_TYPE_TRANSLUCENT  1:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MV1_VertexLighting_ToonType1_FS_Code[ 2 ][ 2 ][ 2 ][ 2 ][ 10 ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// f`p̒_PʃCeBOgD[^CvQptOgVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ gD[_ÕXtBA}bv̗Lƃuh^Cv( 0:XtBA}bv͖   1:MV1_LAYERBLEND_TYPE_MODULATE  2:MV1_LAYERBLEND_TYPE_ADDITIVE ) ]
	// [ CgCfbNX ]
	// [ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MV1_VertexLighting_ToonType2_FS_Code[ 2 ][ 3 ][ 10 ][ ANDROID_FS_ALPHATEST_NUM ] ;

	// f`p̒_PʃCeBOtOgVF[_[
	// [ VhE}bv̗L( 0: 1:L ) ]
	// [ }`eNX`̃uh[hAMV1_LAYERBLEND_TYPE_TRANSLUCENT Ȃǂ +1  ( 0:}`eNX`  1:uh  2:Zuh  3:Zuh  4:Zuh~2 ) ]
	// [ ov}bv ( 0:Ȃ 1: ) ]
	// [ CgCfbNX ]
	// [ tOgVF[_[̃At@eXg[h ]
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO MV1_VertexLighting_Normal_FS_Code[ 2 ][ 5 ][ 2 ][ 10 ][ ANDROID_FS_ALPHATEST_NUM ] ;
} ;

#endif // DX_NON_MODEL


// VF[_[R[ȟf[^Z߂\
struct GRAPHICS_HARDWARE_ANDROID_SHADERCODE
{
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_BASE	Base ;				// W`揈p̃VF[_[R[hZ߂\
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_BASE3D	Base3D ;			// WRc`揈p̃VF[_[R[hZ߂\

#ifndef DX_NON_MODEL
	GRAPHICS_HARDWARE_ANDROID_SHADERCODE_MODEL	Model ;				// f`揈p̃VF[_[R[hZ߂\
#endif // DX_NON_MODEL
} ;


// Android ֌W̐ݒ̍\
struct GRAPHICS_HARDDATA_ANDROID_SETTING
{
	int								UseMinFeatureLevelAndroid ;				// Android ŎgpŒ@\x
	int								UserDepthBufferSizeSet ;					// O[xobt@TCY̎w肪ǂ
	int								UserDepthBufferBitDepthSet ;				// O[xobt@̃rbg[xw肪ǂ

	int								UseOldDrawModiGraphCodeFlag ;				// ȑO DrawModiGraph ֐R[hgp邩ǂ̃tO
} ;



// Android ̃eNX`p̍\
struct GRAPHICS_HARDDATA_ANDROID_TEXTURE
{
	void *											CommonBuffer ;					// eNX`摜]p̋L
	unsigned int									CommonBufferSize ;				// eNX`摜]p̋L̃TCY
} ;

// Android gOtBbNX̍\
struct GRAPHICS_HARDDATA_ANDR
{
	int												UsePixelLightingShader ;	// sNZPʂŃCeBOs^CṽVF[_[gp邩ǂ( TRUE:gp  FALSE:gpȂ )

	GRAPHICS_HARDDATA_ANDROID_SETTING				Setting ;					// Android ֌W̐ݒ

	GRAPHICS_HARDDATA_ANDROID_DEVICE				Device ;					// AndroidDevice ɖڂɊ֘A

	GRAPHICS_HARDWARE_ANDROID_SHADERCODE			ShaderCode ;				// FragmentShader  VertexShader ̌ƂȂVF[_[R[hf[^Z߂\

	GRAPHICS_HARDDATA_ANDROID_TEXTURE				Texture ;					// Android ̃eNX`p̍\
} ;

struct DX_ANDROID_RENDER_BLEND_INFO
{
	int									RenderType ;
	int									BlendEnable ;
	GLenum								ColorSourceMul ;
	GLenum								ColorDestMul ;
	GLenum								ColorBlendFunc ;
	GLenum								AlphaSourceMul ;
	GLenum								AlphaDestMul ;
	GLenum								AlphaBlendFunc ;
	int									AlphaZeroNotDrawFlag ;
} ;

// ϐ錾 --------------------------------------------------------------

extern GLenum g_DXCmpModeToGLES2CompareFunc[ 9 ] ;
extern DX_ANDROID_RENDER_BLEND_INFO g_DefaultBlendDescArray[ DX_BLENDMODE_NUM ] ;
extern PIXELFORMAT_INFO_ANDR g_AndroidPixelFormat[ ANDROID_PIXEL_FORMAT_NUM ] ;
extern GRAPHICS_HARDDATA_ANDR GraphicsHardDataAndroid ;

// ֐vg^Cv錾-----------------------------------------------------------

// Android ̏֌W
extern	int		Graphics_Android_Initialize( void ) ;								// Android gpOtBbNX̏s( 0: -1:s )
extern	int		Graphics_Android_Terminate( void ) ;								// Android gpOtBbNX̌ns

extern	int		Graphics_Android_ReleaseObjectAll( void ) ;							// ׂĂ OpenGL ES nIuWFNg
extern	int		Graphics_Android_CreateObjectAll( void ) ;							// ׂĂ OpenGL ES nIuWFNg쐬


















// VF[_[R[h֌W
extern	int		Graphics_Android_ShaderCode_Base_Initialize( void ) ;				// Android ̕W`p̃VF[_[R[h̏s
extern	int		Graphics_Android_ShaderCode_Base_Terminate( void ) ;				// Android ̕W`p̃VF[_[R[ȟns

extern	int		Graphics_Android_ShaderCode_Base3D_Initialize( void ) ;			// Android ̕WRc`p̃VF[_[R[h̏s
extern	int		Graphics_Android_ShaderCode_Base3D_Terminate( void ) ;			// Android ̕WRc`p̃VF[_[R[ȟns

#ifndef DX_NON_MODEL

extern	int		Graphics_Android_ShaderCode_Model_Initialize( void ) ;			// Android ̃f`p̃VF[_[R[h̏s
extern	int		Graphics_Android_ShaderCode_Model_Terminate( void ) ;			// Android ̃f`p̃VF[_[R[ȟns

#endif // DX_NON_MODEL

extern	int		Graphics_Android_Shader_Initialize( void ) ;					// Android ̃VF[_[̏s
extern	int		Graphics_Android_Shader_Terminate( void ) ;						// Android ̃VF[_[̌n

extern	GRAPHICS_ANDROID_SHADER *Graphics_Android_GetShaderStruct( void ) ;		// VVF[_[\̂擾
extern	int		Graphics_Android_ShaderList_Terminate( void ) ;					// VF[_[񃊃Xǧns

extern	int		Graphics_Android_VertexShader_Create(			GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO	*Code, GLuint *pDestShader, int Num ) ;		// VF[_[R[h璸_VF[_[쐬
extern	void	Graphics_Android_VertexShaderArray_Release(		GLuint										*pObject,					int Num ) ;		// _VF[_[z
extern	int		Graphics_Android_FragmentShader_Create(			GRAPHICS_HARDWARE_ANDROID_SHADERCODE_INFO	*Code, GLuint *pDestShader, int Num ) ;		// VF[_[R[htOgVF[_[쐬
extern	void	Graphics_Android_FragmentShaderArray_Release(	GLuint										*pObject,					int Num ) ;		// tOgVF[_[z

extern	GLuint	Graphics_Android_Shader_GetUniformIndex(		GRAPHICS_ANDROID_SHADER *ShaderInfo, const GLchar *UniformName ) ;						// VF[_[ Uniform ԍ擾
extern	int		Graphics_Android_Shader_Create(					GRAPHICS_ANDROID_SHADER *ShaderInfo, GLuint VertexShader, GLuint FragmentShader ) ;		// _VF[_[ƃtOgVF[_[VF[_[ZbgAbv
extern	void	Graphics_Android_ShaderArray_Release(			GRAPHICS_ANDROID_SHADER *pShaderInfo,	int Num ) ;										// VF[_[z

extern	int		Graphics_Android_Shader_Normal3DDraw_Setup( void ) ;				// RcW`̎w̒_p̕`pVF[_[ZbgAbv
extern	int		Graphics_Android_Shader_GetAlphaTestModeIndex( int AlphaTestEnable, int AlphaTestMode /* DX_CMP_NEVER  */ ) ;	// At@eXg̔r[htOgVF[_[̃At@eXg[h( ANDROID_FS_ALPHATEST_CMP_GREATER  )擾










// _obt@ECfbNXobt@֌W










// Android ̉ʊ֌W
extern	int		Graphics_Android_SetupSubBackBuffer( void ) ;															// TuobNobt@gp鏀s( 0:  -1:s )
extern	int		Graphics_Android_TerminateSubBackBuffer( void ) ;														// TuobNobt@̌ns( 0:  -1:s )
extern	int		Graphics_Android_FrontScreenProcess( void ) ;															// \ʂ`̍ۂ̒















// Android ̉摜֌W
extern COLORDATA *Graphics_Android_GetDataFormatColorData( int PixelFormat ) ;									// ANDROID_PIXEL_FORMAT_R8G8B8A8 Ȃǂ̃tH[}bgɍ킹J[tH[}bg擾

// `peNX`ƕ`peNX`ĂꍇɁA`peNX`ɕ`peNX`̓e𔽉f
//extern	int		Graphics_Android_UpdateDrawTexture( IMAGEDATA_ORIG_HARD_TEX *OrigTex, int TargetSurface, D_DXGI_FORMAT Format ) ;

extern	int		Graphics_Android_Texture_SetupCommonBuffer( unsigned int Size ) ;		// eNX`摜]p̋L̃ZbgAbvs
extern	int		Graphics_Android_Texture_TerminateCommonBuffer( void ) ;				// eNX`摜]p̋Ľns

// t[obt@ɃeNX`̒P]s
extern	int		Graphics_Android_StretchRect(
	GLuint					SrcTexture,				uint32_t SrcTextureWidth,       uint32_t SrcTextureHeight,       const RECT *SrcRect,			// NULL őS
	GLuint					FrameBuffer,			uint32_t FrameBufferWidth,      uint32_t FrameBufferHeight,      const RECT *DestRect,			// NULL őS
	GLenum					FilterType = GL_NEAREST,
	int						AlphaBlend = FALSE,
	GRAPHICS_ANDROID_SHADER	*Shader = NULL,
	GLuint					BlendTexture = 0,		uint32_t BlendTextureWidth = 0, uint32_t BlendTextureHeight = 0, const RECT *BlendRect = NULL,	// NULL őS
	VERTEX_TEX8_2D *		Texcoord8Vertex = NULL
) ;

// w̃eNX`̓eɓǂݍ݃ANZXł悤ɂ
extern	int		Graphics_Android_Texture_Map(
	GLuint				TargetTexture,
	GLuint				TargetFrameBuffer/* = 0 */,
	GLuint				TargetWidth,
	GLuint				TargetHeight,
	const RECT *		MapRect /* NULL őS */,
	BASEIMAGE *			MapBaseImage,
	void **				MapTempImage
) ;

// w̃eNX`̓eւ̓ǂݍ݃ANZXI
extern	int		Graphics_Android_Texture_Unmap( void * MapTempImage ) ;

// eNX`ɃC[Wf[^]
extern int Graphics_Android_BltBmpOrBaseImageToGraph3_NoMipMapBlt(
	const RECT				*SrcRect,
	const RECT				*DestRect,
	      GLuint			UseTex,
	      int				ImageNum,
	      int				TexWidth,
	      int				TexHeight,
	      int				TexUseWidth,
	      int				TexUseHeight,
	const BASEIMAGE			*RgbBaseImage,
	const BASEIMAGE			*AlphaBaseImage,
	      int				DestColorFormat,
	      int				RedIsAlphaFlag,
	      int				UseTransColorConvAlpha,
	      unsigned int		TransCode,
	      int				ASyncThread
) ;




// AndroidDevice ̏֌W
extern	int		Graphics_Android_Device_Create( void ) ;																// Direct3DDevice11 IuWFNg̍쐬( 0:  -1:s )
extern	int		Graphics_Android_Device_Delete( void ) ;																// foCX̔jɑ鏈s

extern	int		Graphics_Android_Device_Initialize( void ) ;															// Direct3DDevice11 ֌W̏









// AndroidDevice Xe[^X֌W
extern	void	Graphics_Android_DeviceState_RefreshRenderState( void ) ;												// `ݒtbV
extern	int		Graphics_Android_DeviceState_SetBaseState( void ) ;														// Direct3DDevice11 ̊{ݒs
extern	int		Graphics_Android_DeviceState_SetSampleFilterMode( GLenum Filter, int Sampler = -1 ) ;		// Tv[̃eNX`tB^O[hݒ肷
extern	int		Graphics_Android_DeviceState_SetDepthEnable( BOOL DepthEnable )  ;									// [xobt@̗L̃Zbg
extern	int		Graphics_Android_DeviceState_SetDepthWriteEnable( int Flag ) ;										// [xobt@݂̗̏LZbg
extern	int		Graphics_Android_DeviceState_SetDepthFunc( GLenum DepthFunc ) ;						// [xl̔r^CvZbg
extern	int		Graphics_Android_DeviceState_SetDepthBias( int DepthBias ) ;										// [xl̃oCAXZbg
extern	int		Graphics_Android_DeviceState_SetWorldMatrix( const MATRIX *Matrix ) ;								// [hϊpsZbg
extern	int		Graphics_Android_DeviceState_SetViewMatrix( const MATRIX *Matrix ) ;								// r[ϊpsZbg
extern	int		Graphics_Android_DeviceState_SetProjectionMatrix( const MATRIX *Matrix ) ;							// eϊpsZbg
extern	int		Graphics_Android_DeviceState_SetAntiViewportMatrix( const MATRIX *Matrix ) ;							// A`r[|[gsZbg
extern	int		Graphics_Android_DeviceState_SetLightState( int LightNumber, LIGHTPARAM *Light ) ;					// Cg̃Zbg
extern	int		Graphics_Android_DeviceState_SetLightEnable( int LightNumber, int EnableState ) ;						// Cg̗LAύX
extern	int		Graphics_Android_DeviceState_SetMaterial( MATERIALPARAM *Material ) ;									// }eÃZbg
extern	int		Graphics_Android_DeviceState_SetSpecularEnable( int UseFlag ) ;										// XyLgp邩ǂZbg
extern	int		Graphics_Android_DeviceState_SetUseVertexDiffuseColor( int UseFlag ) ;								// _̃fBt[YJ[}eÃfBt[YJ[ƂĎgp邩ǂݒ肷
extern	int		Graphics_Android_DeviceState_SetUseVertexSpecularColor( int UseFlag ) ;								// _̃XyLJ[}eÃXyLJ[ƂĎgp邩ǂݒ肷
extern	int		Graphics_Android_DeviceState_SetCullMode( int State ) ;												// JO̗LZbg 
extern	int		Graphics_Android_DeviceState_SetAmbient( COLOR_F *Color ) ;											// ArGgJ[̃Zbg
extern	int		Graphics_Android_DeviceState_SetTextureAddress( int AddressMode, int Sampler = -1 ) ;				// eNX`[̃AhbVO[hZbg
extern	int		Graphics_Android_DeviceState_SetTextureAddressU( int AddressMode, int Sampler = -1 ) ;				// eNX`[̃AhbVO[hZbg
extern	int		Graphics_Android_DeviceState_SetTextureAddressV( int AddressMode, int Sampler = -1 ) ;				// eNX`[̃AhbVO[hZbg
extern	int		Graphics_Android_DeviceState_SetTextureAddressW( int AddressMode, int Sampler = -1 ) ;				// eNX`[̃AhbVO[hZbg
extern	int		Graphics_Android_DeviceState_SetTextureAddressUVW( int AddressModeU, int AddressModeV, int AddressModeW, int Sampler = -1 ) ;		// eNX`[̃AhbVO[hZbg
extern	int		Graphics_Android_DeviceState_SetTextureAddressTransformMatrix( int Use, MATRIX *Matrix ) ;			// eNX`WϊsZbg
extern	int		Graphics_Android_DeviceState_SetFogEnable( int Flag ) ;												// tHOLɂ邩ǂݒ肷( TRUE:L  FALSE: )
extern	int		Graphics_Android_DeviceState_SetFogVertexMode( int Mode /* DX_FOGMODE_NONE  */ ) ;				// tHO[hݒ肷
extern	int		Graphics_Android_DeviceState_SetFogColor( unsigned int Color ) ;									// tHOJ[ύX
extern	int		Graphics_Android_DeviceState_SetFogStartEnd( float Start, float End ) ;								// tHOn܂鋗ƏI鋗ݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_Android_DeviceState_SetFogDensity( float Density ) ;										// tHO̖xݒ肷( 0.0f ` 1.0f )
extern	int		Graphics_Android_DeviceState_SetLighting( int UseFlag ) ;											// CeBO̗LtOZbg
extern	int		Graphics_Android_DeviceState_SetMaxAnisotropy( int MaxAnisotropy, int Sampler = -1 ) ;				// őٕZbg
extern	int		Graphics_Android_DeviceState_SetViewport( RECT *Viewport ) ;										// r[|[gZbg
extern	int		Graphics_Android_DeviceState_SetViewportEasy( int x1, int y1, int x2, int y2 ) ;					// r[|[gZbg( ȈՔ )
extern	int		Graphics_Android_DeviceState_SetDrawMode( int DrawMode ) ;											// `惂[h̃Zbg
extern	int		Graphics_Android_DeviceState_SetAlphaTestCmpMode( int AlphaTestCmpMode /* DX_CMP_NEVER Ȃ */ ) ;	// At@eXgŎgpr[hݒ肷
extern	int		Graphics_Android_DeviceState_SetAlphaTestRef( int AlphaTestRef ) ;									// At@eXgŎgpQƒlݒ肷
extern	int		Graphics_Android_DeviceState_SetMulAlphaColor( int UseMulAlphaColor ) ;								// J[ɃAt@lZ邩ǂݒ肷
extern	int		Graphics_Android_DeviceState_SetBackgroundColor( int Red, int Green, int Blue, int Alpha ) ;		// wiFݒ肷
extern	int		Graphics_Android_DeviceState_SetFactorColor( const DX_ANDR_SHADER_FLOAT4 *FactorColor ) ;			// Factor Color ݒ肷
extern	int		Graphics_Android_DeviceState_SetToonOutLineSize( float Size ) ;										// gD[_O̗֊s̑ݒ肷
extern	int		Graphics_Android_DeviceState_SetBlendMode( int BlendMode, int NotWriteAlphaChannelFlag ) ;			// `uh[h̃Zbg
extern	int		Graphics_Android_DeviceState_SetRenderTarget( GLuint TargetFrameBuffer, GLuint TargetFrameBufferWidth, GLuint TargetFrameBufferHeight ) ;	// `Ώۂ̕ύX
extern	int		Graphics_Android_DeviceState_SetShader( GRAPHICS_ANDROID_SHADER *Shader, int NormalVertexShader = FALSE ) ;			// gpVF[_[ύX
extern	int		Graphics_Android_DeviceState_ResetShader( int SetNormalShaderCancel = FALSE ) ;						// VF[_[̎gp~߂
extern	int		Graphics_Android_DeviceState_UpdateShaderUniform( GRAPHICS_ANDROID_SHADER *Shader, int LightNum, int UseLocalWorldMatrixUniformNum = 3 ) ;	// VF[_[ Uniform XV
extern	int		Graphics_Android_DeviceState_SetupShaderVertexData( GRAPHICS_ANDROID_SHADER *Shader, VERTEXBUFFER_INPUT_INFO_ANDR *VertexInputInfo, const void *VertexData, GLuint VertexBuffer = 0 ) ;	// w̃VF[_[̒_tH[}bg̒_f[^̕`揀s
extern	int		Graphics_Android_DeviceState_SetVertexBuffer( GLuint VertexBuffer ) ;								// gp钸_obt@ύX
extern	int		Graphics_Android_DeviceState_SetTexture( int SlotIndex, GRAPHICS_ANDROID_TEXTURE *Texture ) ;		// VF[_[ŎgpeNX`ύX
extern	int		Graphics_Android_DeviceState_NormalDrawSetup( void ) ;												// W`̏s
//extern	int		Graphics_Android_DeviceState_SetupStateAndConstantBuffer( void ) ;								// ݂̐ݒɊÂ ANDRSamplerAANDRPrimitiveSetupAANDRDepthStencilControlAANDRBlendControl ̃ZbgAbvƁA萔obt@̃Abvf[gs






// `ݒ֌W֐
extern	int		Graphics_Android_DrawSetting_SetDrawBlendMode( int BlendMode, int AlphaTestValidFlag, int AlphaChannelValidFlag ) ;	// `uh[h̐ݒ
extern	int		Graphics_Android_DrawSetting_SetIgnoreDrawGraphColor( int EnableFlag ) ;							// `掞̉摜̂qfa𖳎邩ǂݒ肷
extern	int		Graphics_Android_DrawSetting_SetIgnoreDrawGraphAlpha( int EnableFlag ) ;							// `掞̉摜̂`𖳎邩ǂݒ肷
extern	int		Graphics_Android_DrawSetting_SetWriteAlphaChannelFlag( int NotFlag ) ;								// `̃At@`l̓e邩ݒ肷
extern	int		Graphics_Android_DrawSetting_SetDrawAlphaTest( int TestMode, int TestParam ) ;						// At@eXg̐ݒ
extern	int		Graphics_Android_DrawSetting_SetBlendTextureParam( int BlendType, int *Param ) ;					// uheNX`̃p[^Zbg
extern	int		Graphics_Android_DrawSetting_SetTexture(      GRAPHICS_ANDROID_TEXTURE *RenderTexture ) ;			// eNX`Zbg 
extern	int		Graphics_Android_DrawSetting_SetBlendTexture( GRAPHICS_ANDROID_TEXTURE *BlendTexture ) ;			// uheNX`Zbg 












// Android ̕`揈֌W
extern	int		Graphics_Android_RenderVertex( int NextUse3DVertex = -1, int ASyncThread = FALSE ) ;	// _obt@ɗ܂_f[^_O
extern	void	FASTCALL Graphics_Android_DrawPreparation( int ParamFlag = 0 ) ;						// `揀s
extern	void	Graphics_Android_RenderBegin( void ) ;													// `R}hJn
extern	void	Graphics_Android_RenderEnd( void ) ;													// `R}hI












// Android g`֌W
extern	void	Graphics_Android_DrawModiTex( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA_HARD_DRAW *DrawTex, bool SimpleDrawFlag ) ;								// eNX`ό`ĕ`悷
extern	void	Graphics_Android_DrawPreparationToShader( int ParamFlag, int Is2D ) ;											// VF[_[`p`OZbgAbv֐










#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_GRAPHICS

#endif // DX_GRAPHICSANDROID_H

