// -------------------------------------------------------------------------------
// 
// 		cwCu		̓vOwb_t@C
// 
// 				Ver 3.21 
// 
// -------------------------------------------------------------------------------

#ifndef DX_INPUTSTRING_H
#define DX_INPUTSTRING_H

#include "DxCompileConfig.h"

#ifndef DX_NON_INPUTSTRING

// CN[h ------------------------------------------------------------------
#include "DxLib.h"

#ifndef DX_NON_KEYEX
#include "Windows/DxDirectX.h"
#include "Windows/DxGuid.h"
#endif // DX_NON_KEYEX

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

#define CHARBUFFER_SIZE				(1024)				// R[hobt@e

// \̒` --------------------------------------------------------------------

#ifndef DX_NON_KEYEX

// NX` --------------------------------------------------------------------

// TSFpNX
//class DX_UIElementSink : public D_ITfUIElementSink, public D_ITfInputProcessorProfileActivationSink, public D_ITfCompartmentEventSink
class DX_UIElementSink : public D_ITfUIElementSink
{
public:
	DX_UIElementSink();
	~DX_UIElementSink();

	// IUnknown
	HRESULT __stdcall QueryInterface	( REFIID riid, void **ppvObj ) ;
	ULONG	__stdcall AddRef			( void ) ;
	ULONG	__stdcall Release			( void ) ;

	// ITfUIElementSink
	//   Notifications for Reading Window events. We could process candidate as well, but we'll use IMM for simplicity sake.
	HRESULT	__stdcall BeginUIElement	( DWORD dwUIElementId, BOOL *pbShow ) ;
	HRESULT	__stdcall UpdateUIElement	( DWORD dwUIElementId ) ;
	HRESULT	__stdcall EndUIElement		( DWORD dwUIElementId ) ;

//	// ITfInputProcessorProfileActivationSink
//	//   Notification for keyboard input locale change
//	HRESULT __stdcall OnActivated		( DWORD dwProfileType, LANGID langid, REFCLSID clsid, REFGUID catid, REFGUID guidProfile, HKL hkl, DWORD dwFlags ) ;
//
//	// ITfCompartmentEventSink
//	//    Notification for open mode (toggle state) change
//	HRESULT __stdcall OnChange			( REFGUID rguid ) ;

private:
	LONG RefCount ;
} ;

// ͒f[^\
struct INPUTDATA
{
	int						UseFlag ;							// gptO

	int						ID ;								// G[`FbNɎgphc

	int						EndFlag ;							// ͂IĂ邩tO
	int						CancellFlag ;						// ͂LZꂽ̃tO

//	RECT					DrawRect ;							// `̈

	int						StrLength ;							// ͒̒
	int						MaxStrLength ;						// ̍ő咷( Unicodeł̏ꍇ wchar_t ̐A}`oCgł̏ꍇ char ̐ )
	int						SelectStart ;						// I͈͊Jnʒu
	int						SelectEnd ;							// I͈͏Iʒu
	int						DrawStartPos ;						// `Jnʒu
	int						Point ;								// J[\̈ʒu
	wchar_t *				Buffer ;							// sɕҏW镶obt@
	char *					TempBuffer ;						// Buffer }`oCgɂ̂i[邽߂̃obt@
	size_t					TempBufferBytes ;					// TempBuffer ̃TCY
//	char					*DestBuffer ;						// ͏Iɓ]镶obt@ւ̃|C^

	int						CancelValidFlag ;					// LZLtO
	int						SingleCharOnlyFlag ;				// _uoCg͈ȂtO
	int						NumCharOnlyFlag ;					// ppgȂtO
	int						DoubleCharOnlyFlag ;				// _uoCgȂtO
	int						EnableNewLineFlag ;					// s邩tO

	int						DrawAreaValidFlag ;					// `\͈͂Lǂ̃tO
	RECT					DrawArea ;							// `\͈
} ;

#endif // DX_NON_KEYEX

// R[hobt@\
struct CHARBUFFER
{
#ifndef UNICODE
	char					TempStock[ 16 ] ;					// QoCg StockInputChar ɓnꂽꍇɂPoCgڂł wchar_t ɕϊłȂ̂ŁAQoCgڂn܂ł̈ꎞۑpϐ
	int						TempStockNum ;						// TempStock ɑĂLȃoCg

	char					TempGetStock[ 16 ] ;				// QoCg GetInputChar Ŏ擾Ƃ wchar_t  char ɕϊAx GetInputChar ł͖߂lƂēnȂ̂ŁAwchar_t  char ɕϊꎞIɕۑ邽߂̕ϐ
	int						TempGetStockNum ;					// TempGetStock ɑĂLȃoCg
#endif // UNICODE

	wchar_t					CharBuffer[ CHARBUFFER_SIZE + 1 ] ;	// ͂ꂽ
	int						StPoint , EdPoint ;					// Oobt@p|C^

	wchar_t					SecondString[CHARBUFFER_SIZE + 1 ] ;
	int						IMEInputFlag ;						// ͏AtO
	int						InputPoint ;						// ͒̕ҏẄʒu
	wchar_t					InputString[ CHARBUFFER_SIZE + 1 ] ;// hldɂ͒̕
	wchar_t					InputTempString[ CHARBUFFER_SIZE + 1 ] ;// hldɂ͒̃̕e|obt@
	PCANDIDATELIST			CandidateList ;						// ϊ̃Xgf[^
	int						CandidateListSize ;					// ϊ̃Xgf[^ɕKvȃf[^e
	int						IMEUseFlag ;						// hld̎gp
	int						IMEUseFlag_System ;					// hld̎gp( cwCup )
	int						IMEUseFlag_OSSet ;					// nrɑ΂Đݒ肵Ăhld̎gp
	HIMC					IMEContext ;						// hld̓̓ReLXg
	int						IMESwitch ;							// hld̋N
	int						IMEInputStringMaxLengthIMESync ;	// hldœ͂łő啶 MakeKeyInput ̍ő吔ɓ邩ǂ( TRUE:  FALSE:Ȃ )
	int						IMEInputMaxLength ;					// hldňxɓ͂ł镶( 0:ɐȂ  1ȏ: )
	int						IMERefreshStep ;					// hld͕̓񃊃tbVpXebvϐ
	IMEINPUTDATA			*IMEInputData ;						// hld̓͒̏( [U[p )
	int						TSFNotUseFlag ;						// hld̕ϊ\ TSF gpȂǂ̃tO

	int						IMEProcessNum ;						// hld̕擾vZXԍ
	int						ClauseData[ 1024 ] ;				// ߃f[^
	int						ClauseNum ;							// ߐ
	BYTE					CharAttr[ 1024 ] ;					// ȇ
	int						CharAttrNum ;						// ȇ̗vf
	int						ChangeFlag ;						// hld͂ɕωtO

	DWORD					NormalStrColor ;					// ͕̐F
	DWORD					NormalStrEdgeColor ;				// ͕̉̐F
	DWORD					NormalCursorColor ;					// hldgp̃J[\̐F
	DWORD					SelectStrColor ;					// Iꂽ͕̐F
	DWORD					SelectStrEdgeColor ;				// Iꂽ͕̉̐F
	DWORD					SelectStrBackColor ;				// Iꂽ͕̔wi̐F
	DWORD					IMEStrColor ;						// hldgp͕̓̐F
	DWORD					IMEStrEdgeColorEnable ;				// IMEStrEdgeColor Lǂ( TRUE:L  FALSE: )
	DWORD					IMEStrEdgeColor ;					// hldgp͕̓̉̐F
	DWORD					IMEStrBackColor ;					// hldgp͕̓̎̐F
	DWORD					IMECursorColor ;					// hldgp̃J[\̐F
	DWORD					IMELineColor ;						// hldgp̕ϊ̉
	DWORD					IMESelectStrColor ;					// hldgp̑IΏۂ̕ϊ╶̐F
	DWORD					IMESelectStrEdgeColorEnable ;		// IMESelectStrEdgeColor Lǂ( TRUE:L  FALSE: )
	DWORD					IMESelectStrEdgeColor ;				// hldgp̑IΏۂ̕ϊ╶̉̐F
	DWORD					IMESelectStrBackColor ;				// hldgp̑IΏۂ̕ϊ╶̎̐F
	DWORD					IMEConvWinStrColor ;				// hldgp̕ϊEChE̐̕F
	DWORD					IMEConvWinStrEdgeColor ;			// hldgp̕ϊEChẺ̐̕F
	DWORD					IMEConvWinSelectStrColor ;			// hldgp̕ϊEChEőIĂ镶̐F
	DWORD					IMEConvWinSelectStrEdgeColor ;		// hldgp̕ϊEChEőIĂ镶̉̐F
	DWORD					IMEConvWinSelectStrBackColorEnable ;// IMEConvWinSelectStrBackColor Lǂ( TRUE:L  FALSE: )
	DWORD					IMEConvWinSelectStrBackColor ;		// hldgp̕ϊEChEőIĂ镶̎̐F
	DWORD					IMEConvWinEdgeColor ;				// hldgp̕ϊEChẺ̐F
	DWORD					IMEConvWinBackColor ;				// hldgp̕ϊEChẺn̐F
	DWORD					IMEModeStrColor ;					// hldgp̓̓[h̐F(uSpЂ炪ȁv)
	DWORD					IMEModeStrEdgeColor ;				// hldgp̓̓[h̉̐F

	int						EndCharaMode ;						// ͏͕̓EɒBĂԂŁA̖[œ͂sꂽꍇ̏[h( DX_KEYINPSTR_ENDCHARAMODE_OVERWRITE  )
	
	int						CBrinkFlag ;						// J[\_ł邩AtO
	int						CBrinkCount ;						// J[\_łꍇ̃JE^
	int						CBrinkWait ;						// J[\̓_ł̑x
	int						CBrinkDrawFlag ;					// J[\`悷邩ǂ̃tO

	int						ActiveInputHandle ;					// ͂ANeBuɂȂĂ̓nh
	int						UseFontHandle ;						// `ɎgptHg̃nh(-1ŃftHg̃nh)
#ifndef DX_NON_KEYEX
	INPUTDATA				InputData[ MAX_INPUT_NUM ] ;		// Cvbgf[^
	int						HandleID ;							// nhɊ蓖Ăhc

	D_ITfThreadMgrEx		*ITfThreadMgrEx ;
	DX_UIElementSink		*TsfSink ;
	int						TsfCandidateRefCount ;
	DWORD					TsfElementSinkCookie ;
#endif
} ;

// ̓[h\
struct INPUTMODE
{
	DWORD					InputState ;						// ̓[hl
	wchar_t					InputName[ 16 ] ;					// ̓[hl[
} ;

// e[u-----------------------------------------------------------------------

// zL[R[hRg[R[hɕϊ邽߂̃e[u
extern char CtrlCode[ 10 ][ 2 ] ;

// ϐ錾 --------------------------------------------------------------

// ̓f[^
extern CHARBUFFER CharBuf ;

// ֐vg^Cv錾-----------------------------------------------------------

// R[hobt@֌W
extern	int			InitializeInputCharBuf( void ) ;										// R[hobt@֌W̏
extern	int			TerminateInputCharBuf( void ) ;											// R[hobt@֌W̌n
#ifndef DX_NON_KEYEX
extern	LRESULT		IMEProc( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam ) ;			// hldbZ[W̃R[obN֐
extern	void		RefreshIMEFlag( int Always = FALSE ) ;										// hldgp邩ǂ̏ԂXV
#endif


// wchar_tŊ֐
#ifndef DX_NON_INPUTSTRING
extern	int			StockInputChar_WCHAR_T(		wchar_t CharCode ) ;
extern	wchar_t		GetInputChar_WCHAR_T(		int DeleteFlag ) ;
extern	wchar_t		GetInputCharWait_WCHAR_T(	int DeleteFlag ) ;
extern	int			GetOneChar_WCHAR_T(			wchar_t *CharBuffer, int DeleteFlag ) ;
extern	int			GetOneCharWait_WCHAR_T(		wchar_t *CharBuffer, int DeleteFlag ) ;
extern	int			GetCtrlCodeCmp_WCHAR_T(		wchar_t Char ) ;
#endif // DX_NON_INPUTSTRING

extern	int			GetStringPoint_WCHAR_T(				const wchar_t *String, int Point ) ;
extern	int			GetStringPoint2_WCHAR_T(			const wchar_t *String, int Point ) ;
extern	int			GetStringLength_WCHAR_T(			const wchar_t *String ) ;

#ifndef DX_NON_FONT
extern	int			DrawObtainsString_WCHAR_T(			int x, int y, int AddY, const wchar_t *String, int StrLen, unsigned int StrColor, unsigned int StrEdgeColor = 0 , int FontHandle = -1 , unsigned int SelectBackColor = 0xffffffff , unsigned int SelectStrColor = 0 , unsigned int SelectStrEdgeColor = 0xffffffff , int SelectStart = -1 , int SelectEnd = -1 , int DrawFlag = TRUE, int *PosX = NULL, int *PosY = NULL ) ;
extern	int			DrawObtainsString_CharClip_WCHAR_T(	int x, int y, int AddY, const wchar_t *String, int StrLen, unsigned int StrColor, unsigned int StrEdgeColor = 0 , int FontHandle = -1 , unsigned int SelectBackColor = 0xffffffff , unsigned int SelectStrColor = 0 , unsigned int SelectStrEdgeColor = 0xffffffff , int SelectStart = -1 , int SelectEnd = -1 , int DrawFlag = TRUE, int *PosX = NULL, int *PosY = NULL ) ;
#endif // DX_NON_FONT

#ifndef DX_NON_KEYEX
extern	int			InputStringToCustom_WCHAR_T(		int x, int y, size_t BufLength, wchar_t *StrBuffer, int CancelValidFlag, int SingleCharOnlyFlag, int NumCharOnlyFlag, int DoubleCharOnlyFlag = FALSE , int EnableNewLineFlag = FALSE , int DisplayCandidateList = TRUE ) ;
extern	int			KeyInputString_WCHAR_T(				int x, int y, size_t CharMaxLength, wchar_t *StrBuffer, int CancelValidFlag ) ;
extern	int			KeyInputSingleCharString_WCHAR_T(	int x, int y, size_t CharMaxLength, wchar_t *StrBuffer, int CancelValidFlag ) ;
extern	int			GetIMEInputModeStr_WCHAR_T(			wchar_t *GetBuffer ) ;
extern	int			SetKeyInputString_WCHAR_T(			const wchar_t *String, int InputHandle ) ;
extern	int			GetKeyInputString_WCHAR_T(			wchar_t *StrBuffer,    int InputHandle ) ;
#endif // DX_NON_KEYEX



#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_NON_INPUTSTRING

#endif // DX_INPUTSTRING_H
