// -------------------------------------------------------------------------------
// 
// 		cwCu		Live2D Cubism3 ֌WvOwb_t@C
// 
// 				Ver 3.21 
// 
// -------------------------------------------------------------------------------

#ifndef DXLIVE2D_CUBISM3_H
#define DXLIVE2D_CUBISM3_H

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"

#ifndef DX_NON_LIVE2D_CUBISM3
#include "DxUseCLibLive2DCubism3.h"
#include "DxLib.h"
#include "DxHandle.h"
#include "DxThread.h"
#include "DxGraphics.h"
#include "DxBaseFunc.h"
#include "DxStatic.h"

#ifdef WINDOWS_DESKTOP_OS
	#include "Windows/DxLive2DCubism3Win.h"
#endif // WINDOWS_DESKTOP_OS

#ifdef __ANDROID__
	#include "Android/DxLive2DCubism3Android.h"
#endif // __ANDROID__

#ifdef __APPLE__
    #include "TargetConditionals.h"
    #if TARGET_OS_IPHONE
		#include "iOS/DxLive2DCubism3iOS.h"
    #endif // TARGET_OS_IPHONE
#endif // __APPLE__





#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif// DX_NON_NAMESPACE

// }N` --------------------------------------------------------------------

#define LIVE2DSYS					Live2DCubism3SysData
#define LIVE2DDLL					Live2DCubism3DLLData

// \̒` --------------------------------------------------------------------

// t@CLive2Dfnh쐬鏈ɕKvȃO[of[^Z߂
struct LIVE2DCUBISM3_LOADMODEL_GPARAM
{
	int							Dummy ;
} ;

// Live2D Cubism3 f
struct LIVE2DCUBISM3MODEL
{
	HANDLEINFO					HandleInfo ;				// nhʃf[^

	float						PosX ;
	float						PosY ;
	float						ExRateX ;
	float						ExRateY ;
	float						RotAngle ;

	D_LAppModel *				AppModel ;
} ;

// Live2D Cubism3 DLL ̊֐|C^\
struct LIVE2DCUBISM3DLL
{
	wchar_t					Live2DCubismCoreDLLPath[ 1024 ] ;	// Live2D Cubism Core DLL ̃t@CpX

	DWORD					( LIVE2D_CUBISM3_FUNC *csmGetVersion )( void ) ;
	DWORD					( LIVE2D_CUBISM3_FUNC *csmGetLatestMocVersion )( void ) ;
	DWORD					( LIVE2D_CUBISM3_FUNC *csmGetMocVersion )( const void* address, const DWORD size ) ;
	csmLogFunctionP			( LIVE2D_CUBISM3_FUNC *csmGetLogFunction )( void ) ;
	void					( LIVE2D_CUBISM3_FUNC *csmSetLogFunction )( csmLogFunctionP handler ) ;
	void*					( LIVE2D_CUBISM3_FUNC *csmReviveMocInPlace )( void* address, const DWORD size ) ;
	DWORD 					( LIVE2D_CUBISM3_FUNC *csmGetSizeofModel )( const void* moc ) ;
	void* 					( LIVE2D_CUBISM3_FUNC *csmInitializeModelInPlace )( const void* moc, void* address, const DWORD size ) ;
	void 					( LIVE2D_CUBISM3_FUNC *csmUpdateModel )( void* model ) ;
	void 					( LIVE2D_CUBISM3_FUNC *csmReadCanvasInfo )( const void* model, D_CubismVector2* outSizeInPixels, D_CubismVector2* outOriginInPixels, float* outPixelsPerUnit ) ;
	int 					( LIVE2D_CUBISM3_FUNC *csmGetParameterCount )( const void* model ) ;
	const char** 			( LIVE2D_CUBISM3_FUNC *csmGetParameterIds )( const void* model ) ;
	const float*			( LIVE2D_CUBISM3_FUNC *csmGetParameterMinimumValues )( const void* model ) ;
	const float*			( LIVE2D_CUBISM3_FUNC *csmGetParameterMaximumValues )( const void* model ) ;
	const float*			( LIVE2D_CUBISM3_FUNC *csmGetParameterDefaultValues )( const void* model ) ;
	float* 					( LIVE2D_CUBISM3_FUNC *csmGetParameterValues )( void* model ) ;
	int 					( LIVE2D_CUBISM3_FUNC *csmGetPartCount )( const void* model ) ;
	const char**			( LIVE2D_CUBISM3_FUNC *csmGetPartIds )( const void* model ) ;
	float*					( LIVE2D_CUBISM3_FUNC *csmGetPartOpacities ) (void* model ) ;
	const int*				( LIVE2D_CUBISM3_FUNC *csmGetPartParentPartIndices )( const void* model ) ;
	int 					( LIVE2D_CUBISM3_FUNC *csmGetDrawableCount )( const void* model ) ;
	const char**			( LIVE2D_CUBISM3_FUNC *csmGetDrawableIds )( const void* model ) ;
	const BYTE*				( LIVE2D_CUBISM3_FUNC *csmGetDrawableConstantFlags )( const void* model ) ;
	const BYTE*				( LIVE2D_CUBISM3_FUNC *csmGetDrawableDynamicFlags )( const void* model ) ;
	const int*				( LIVE2D_CUBISM3_FUNC *csmGetDrawableTextureIndices )( const void* model ) ;
	const int*				( LIVE2D_CUBISM3_FUNC *csmGetDrawableDrawOrders )( const void* model ) ;
	const int*				( LIVE2D_CUBISM3_FUNC *csmGetDrawableRenderOrders )( const void* model ) ;
	const float*			( LIVE2D_CUBISM3_FUNC *csmGetDrawableOpacities )( const void* model ) ;
	const int*				( LIVE2D_CUBISM3_FUNC *csmGetDrawableMaskCounts )( const void* model ) ;
	const int**				( LIVE2D_CUBISM3_FUNC *csmGetDrawableMasks )( const void* model ) ;
	const int*				( LIVE2D_CUBISM3_FUNC *csmGetDrawableVertexCounts )( const void* model ) ;
	const D_CubismVector2**	( LIVE2D_CUBISM3_FUNC *csmGetDrawableVertexPositions )( const void* model ) ;
	const D_CubismVector2**	( LIVE2D_CUBISM3_FUNC *csmGetDrawableVertexUvs )( const void* model ) ;
	const int*				( LIVE2D_CUBISM3_FUNC *csmGetDrawableIndexCounts )( const void* model ) ;
	const unsigned short**	( LIVE2D_CUBISM3_FUNC *csmGetDrawableIndices )( const void* model ) ;
	void					( LIVE2D_CUBISM3_FUNC *csmResetDrawableDynamicFlags )( void* model ) ;
} ;

// Live2D Cubism3 VXepf[^\
struct LIVE2DCUBISM3SYSTEMDATA
{
	int						InitializeFlag ;				// tO

	int						EnableConstantBuffer ;			// RX^gobt@gpł邩ǂ

	D_CubismIdManager *		s_cubismIdManager ;

	DXARC					ShaderBinDxa ;					// VF[_[IuWFNgt@Ccw`\
	void					*ShaderBinDxaImage ;			// VF[_[IuWFNgt@Ccw`̃oCiC[W

	LIVE2DCUBISM3SYSTEMDATA_PF	PF ;						// ˑf[^
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// Live2D Cubism3 VXef[^
extern LIVE2DCUBISM3SYSTEMDATA Live2DCubism3SysData ;

// Live2D Cubism 3 DLL
extern LIVE2DCUBISM3DLL Live2DCubism3DLLData ;

// ֐vg^Cv錾-----------------------------------------------------------

// Live2D Cubism3 ֘Ȁƌn
extern	int		Live2DCubism3_Initialize( void ) ;					// Live2D Cubism3 ̏
extern	int		Live2DCubism3_Terminate( void ) ;					// Live2D Cubism3 ̌n


extern	int		Live2DCubism3_SetupShaderCode( int *ShaderCodeBinConvert, BYTE *ShaderCodeBin ) ;	// VF[_[DXAt@C̃ZbgAbv
extern	int		Live2DCubism3_LoadShaderCode( const char *ShaderName, int ShaderType ) ;			// w薼̃VF[_[ǂݍ

extern	void	Live2DCubism3_InitLoadModelGParam( LIVE2DCUBISM3_LOADMODEL_GPARAM *GParam ) ;		// LIVE2DCUBISM3_LOADMODEL_GPARAM ̃f[^Zbg

extern	int		Live2DCubism3_LoadModel_UseGParam( LIVE2DCUBISM3_LOADMODEL_GPARAM *GParam, const wchar_t *FilePath, int ASyncLoadFlag = FALSE, int ASyncThread = FALSE ) ;				// Live2D_LoadModel ̃O[oϐɃANZXȂo[W




// wchar_tŊ֐
extern	int			Live2D_SetCubism3CoreDLLPath_WCHAR_T(			const wchar_t *CoreDLLFilePath ) ;
extern	int			Live2D_LoadModel_WCHAR_T(						const wchar_t *FilePath ) ;
extern	int			Live2D_Model_StartMotion_WCHAR_T(				int Live2DModelHandle, const wchar_t *group, int no ) ;
extern	int			Live2D_Model_SetExpression_WCHAR_T(				int Live2DModelHandle, const wchar_t *expressionID ) ;
extern	int			Live2D_Model_HitTest_WCHAR_T(					int Live2DModelHandle, const wchar_t *hitAreaName, float x, float y ) ;
extern	int			Live2D_Model_GetMotionCount_WCHAR_T(			int Live2DModelHandle, const wchar_t *groupName ) ;
extern	const TCHAR *Live2D_Model_GetMotionFileName_WCHAR_T(		int Live2DModelHandle, const wchar_t *groupName, int index ) ;
extern	const TCHAR *Live2D_Model_GetMotionSoundFileName_WCHAR_T(	int Live2DModelHandle, const wchar_t *groupName, int index ) ;
extern	float		Live2D_Model_GetMotionFadeInTimeValue_WCHAR_T(	int Live2DModelHandle, const wchar_t *groupName, int index ) ;
extern	float		Live2D_Model_GetMotionFadeOutTimeValue_WCHAR_T(	int Live2DModelHandle, const wchar_t *groupName, int index ) ;



#ifndef DX_NON_NAMESPACE

}

#endif// DX_NON_NAMESPACE



// ˑ֐
extern	int		Live2DCubism3_Initialize_PF( void ) ;										// Live2D Cubism3 ֘Ȁ֐̊ˑs֐
extern	int		Live2DCubism3_Terminate_PF( void ) ;										// Live2D Cubism3 ֘Ǎn֐̊ˑs֐

extern	int		Live2DCubism3_GenerateShaders_PF( void ) ;									// Live2D Cubism3 ̃VF[_[쐬̊ˑs
extern	int		Live2DCubism3_SetupShader_PF( int ConstantBufferHandle, D_CubismConstantBufferDxLib *ConstantBuffer, D_ShaderNames VertexShader, D_ShaderNames PixelShader ) ;	// Live2D Cubism3 ̃VF[_[̃ZbgAbvs
extern	int		Live2DCubism3_DrawAfter_PF( void ) ;										// Live2D Cubism3 ̕`̌ɌĂ΂ˑ֐



#endif// DX_NON_LIVE2D_CUBISM3

#endif// DXLIVE2D_CUBISM3_H
