//-----------------------------------------------------------------------------
// 
// 		cwCu		Live2D Cubism3֌WvO( Windows )
// 
//  	Ver 3.21 
// 
//-----------------------------------------------------------------------------

// cwCu쐬p`
#define DX_MAKE

#include "../DxCompileConfig.h"

#ifndef DX_NON_LIVE2D_CUBISM3

// CN[h----------------------------------------------------------------
#include "../DxLib.h"
#include "../DxStatic.h"
#include "../DxLive2DCubism3.h"
#include "../DxGraphics.h"
#include "../DxMemory.h"
#include "../DxArchive_.h"
#include "../DxLog.h"
#include "DxGraphicsWin.h"

// #ifndef DX_NON_NAMESPACE
// 
// namespace DxLib
// {
// 
// #endif // DX_NON_NAMESPACE

// }N`------------------------------------------------------------------

// ^`----------------------------------------------------------------------

// f[^錾------------------------------------------------------------------

#ifndef DX_NON_DIRECT3D11
extern int  DxShaderCodeBin_Live2D_Cubism3_D3D11Convert ;
extern BYTE DxShaderCodeBin_Live2D_Cubism3_D3D11[] ;
#endif // DX_NON_DIRECT3D11

extern int  DxShaderCodeBin_Live2D_Cubism3_D3D9Convert ;
extern BYTE DxShaderCodeBin_Live2D_Cubism3_D3D9[] ;

// ֐vg^Cv錾 -------------------------------------------------------

// DLL ̓ǂݍ݁E
static	int			Live2DCubism3_DLL_Load( void ) ;														// Live2D Cubism 3 DLL ̓ǂݍ
static	int			Live2DCubism3_DLL_Unload( void ) ;														// Live2D Cubism 3 DLL ̉

// vO------------------------------------------------------------------

// DLL ̓ǂݍ݁E

// Live2D Cubism 3 DLL ̓ǂݍ
static int Live2DCubism3_DLL_Load( void )
{
	if( LIVE2DSYS.PF.Live2DCubismCoreDLL == NULL )
	{
		if( LIVE2DDLL.Live2DCubismCoreDLLPath[ 0 ] != '\0' )
		{
			LIVE2DSYS.PF.Live2DCubismCoreDLL = LoadLibraryW( LIVE2DDLL.Live2DCubismCoreDLLPath ) ;
		}
		else
		{
			LIVE2DSYS.PF.Live2DCubismCoreDLL = LoadLibraryW( L"Live2DCubismCore.dll" ) ;
		}
		if( LIVE2DSYS.PF.Live2DCubismCoreDLL == NULL )
		{
			return -1 ;
		}

		LIVE2DDLL.csmGetVersion						= ( DWORD					( LIVE2D_CUBISM3_FUNC * )( void ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetVersion" ) ;
		LIVE2DDLL.csmGetLatestMocVersion			= ( DWORD					( LIVE2D_CUBISM3_FUNC * )( void ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetLatestMocVersion" ) ;
		LIVE2DDLL.csmGetMocVersion					= ( DWORD					( LIVE2D_CUBISM3_FUNC * )( const void* address, const DWORD size ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetMocVersion" ) ;
		LIVE2DDLL.csmGetLogFunction					= ( csmLogFunctionP			( LIVE2D_CUBISM3_FUNC * )( void ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetLogFunction" ) ;
		LIVE2DDLL.csmSetLogFunction					= ( void					( LIVE2D_CUBISM3_FUNC * )( csmLogFunctionP handler ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmSetLogFunction" ) ;
		LIVE2DDLL.csmReviveMocInPlace				= ( void*					( LIVE2D_CUBISM3_FUNC * )( void* address, const DWORD size ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmReviveMocInPlace" ) ;
		LIVE2DDLL.csmGetSizeofModel					= ( DWORD 					( LIVE2D_CUBISM3_FUNC * )( const void* moc ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetSizeofModel" ) ;
		LIVE2DDLL.csmInitializeModelInPlace			= ( void* 					( LIVE2D_CUBISM3_FUNC * )( const void* moc, void* address, const DWORD size ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmInitializeModelInPlace" ) ;
		LIVE2DDLL.csmUpdateModel					= ( void 					( LIVE2D_CUBISM3_FUNC * )( void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmUpdateModel" ) ;
		LIVE2DDLL.csmReadCanvasInfo					= ( void 					( LIVE2D_CUBISM3_FUNC * )( const void* model, D_CubismVector2* outSizeInPixels, D_CubismVector2* outOriginInPixels, float* outPixelsPerUnit ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmReadCanvasInfo" ) ;
		LIVE2DDLL.csmGetParameterCount				= ( int 					( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetParameterCount" ) ;
		LIVE2DDLL.csmGetParameterIds 				= ( const char** 			( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetParameterIds" ) ;
		LIVE2DDLL.csmGetParameterMinimumValues		= ( const float*			( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetParameterMinimumValues" ) ;
		LIVE2DDLL.csmGetParameterMaximumValues		= ( const float*			( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetParameterMaximumValues" ) ;
		LIVE2DDLL.csmGetParameterDefaultValues		= ( const float*			( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetParameterDefaultValues" ) ;
		LIVE2DDLL.csmGetParameterValues				= ( float* 					( LIVE2D_CUBISM3_FUNC * )( void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetParameterValues" ) ;
		LIVE2DDLL.csmGetPartCount					= ( int 					( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetPartCount" ) ;
		LIVE2DDLL.csmGetPartIds						= ( const char**			( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetPartIds" ) ;
		LIVE2DDLL.csmGetPartOpacities				= ( float*					( LIVE2D_CUBISM3_FUNC * ) (void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetPartOpacities" ) ;
		LIVE2DDLL.csmGetPartParentPartIndices 		= ( const int*				( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetPartParentPartIndices" ) ;
		LIVE2DDLL.csmGetDrawableCount				= ( int 					( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableCount" ) ;
		LIVE2DDLL.csmGetDrawableIds					= ( const char**			( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableIds" ) ;
		LIVE2DDLL.csmGetDrawableConstantFlags 		= ( const BYTE*				( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableConstantFlags" ) ;
		LIVE2DDLL.csmGetDrawableDynamicFlags		= ( const BYTE*				( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableDynamicFlags" ) ;
		LIVE2DDLL.csmGetDrawableTextureIndices		= ( const int*				( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableTextureIndices" ) ;
		LIVE2DDLL.csmGetDrawableDrawOrders			= ( const int*				( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableDrawOrders" ) ;
		LIVE2DDLL.csmGetDrawableRenderOrders		= ( const int*				( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableRenderOrders" ) ;
		LIVE2DDLL.csmGetDrawableOpacities			= ( const float*			( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableOpacities" ) ;
		LIVE2DDLL.csmGetDrawableMaskCounts 			= ( const int*				( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableMaskCounts" ) ;
		LIVE2DDLL.csmGetDrawableMasks				= ( const int**				( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableMasks" ) ;
		LIVE2DDLL.csmGetDrawableVertexCounts		= ( const int*				( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableVertexCounts" ) ;
		LIVE2DDLL.csmGetDrawableVertexPositions		= ( const D_CubismVector2**	( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableVertexPositions" ) ;
		LIVE2DDLL.csmGetDrawableVertexUvs			= ( const D_CubismVector2**	( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableVertexUvs" ) ;
		LIVE2DDLL.csmGetDrawableIndexCounts			= ( const int*				( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableIndexCounts" ) ;
		LIVE2DDLL.csmGetDrawableIndices 			= ( const unsigned short**	( LIVE2D_CUBISM3_FUNC * )( const void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmGetDrawableIndices" ) ;
		LIVE2DDLL.csmResetDrawableDynamicFlags		= ( void					( LIVE2D_CUBISM3_FUNC * )( void* model ) )GetProcAddress( LIVE2DSYS.PF.Live2DCubismCoreDLL, "csmResetDrawableDynamicFlags" ) ;
	}

	// I
	return 0 ;
}

// Live2D Cubism 3 DLL ̉
static int Live2DCubism3_DLL_Unload( void )
{
	if( LIVE2DSYS.PF.Live2DCubismCoreDLL != NULL )
	{
		FreeLibrary( LIVE2DSYS.PF.Live2DCubismCoreDLL ) ;
		LIVE2DSYS.PF.Live2DCubismCoreDLL = NULL ;
	}

	LIVE2DDLL.csmGetVersion						= NULL ;
	LIVE2DDLL.csmGetLatestMocVersion			= NULL ;
	LIVE2DDLL.csmGetMocVersion					= NULL ;
	LIVE2DDLL.csmGetLogFunction					= NULL ;
	LIVE2DDLL.csmSetLogFunction					= NULL ;
	LIVE2DDLL.csmReviveMocInPlace				= NULL ;
	LIVE2DDLL.csmGetSizeofModel					= NULL ;
	LIVE2DDLL.csmInitializeModelInPlace			= NULL ;
	LIVE2DDLL.csmUpdateModel					= NULL ;
	LIVE2DDLL.csmReadCanvasInfo					= NULL ;
	LIVE2DDLL.csmGetParameterCount				= NULL ;
	LIVE2DDLL.csmGetParameterIds 				= NULL ;
	LIVE2DDLL.csmGetParameterMinimumValues		= NULL ;
	LIVE2DDLL.csmGetParameterMaximumValues		= NULL ;
	LIVE2DDLL.csmGetParameterDefaultValues		= NULL ;
	LIVE2DDLL.csmGetParameterValues				= NULL ;
	LIVE2DDLL.csmGetPartCount					= NULL ;
	LIVE2DDLL.csmGetPartIds						= NULL ;
	LIVE2DDLL.csmGetPartOpacities				= NULL ;
	LIVE2DDLL.csmGetPartParentPartIndices 		= NULL ;
	LIVE2DDLL.csmGetDrawableCount				= NULL ;
	LIVE2DDLL.csmGetDrawableIds					= NULL ;
	LIVE2DDLL.csmGetDrawableConstantFlags 		= NULL ;
	LIVE2DDLL.csmGetDrawableDynamicFlags		= NULL ;
	LIVE2DDLL.csmGetDrawableTextureIndices		= NULL ;
	LIVE2DDLL.csmGetDrawableDrawOrders			= NULL ;
	LIVE2DDLL.csmGetDrawableRenderOrders		= NULL ;
	LIVE2DDLL.csmGetDrawableOpacities			= NULL ;
	LIVE2DDLL.csmGetDrawableMaskCounts 			= NULL ;
	LIVE2DDLL.csmGetDrawableMasks				= NULL ;
	LIVE2DDLL.csmGetDrawableVertexCounts		= NULL ;
	LIVE2DDLL.csmGetDrawableVertexPositions		= NULL ;
	LIVE2DDLL.csmGetDrawableVertexUvs			= NULL ;
	LIVE2DDLL.csmGetDrawableIndexCounts			= NULL ;
	LIVE2DDLL.csmGetDrawableIndices 			= NULL ;
	LIVE2DDLL.csmResetDrawableDynamicFlags		= NULL ;

	// I
	return 0 ;
}

// ˑ֐

// Live2D Cubism3 ֘Ȁ֐̊ˑs֐
extern int Live2DCubism3_Initialize_PF( void )
{
	// DLL ̓ǂݍ
	if( Live2DCubism3_DLL_Load() < 0 )
	{
		return -1 ;
	}

	// RX^gobt@gpł邩ǂZbg
	LIVE2DSYS.EnableConstantBuffer = GRAWIN.Setting.UseGraphicsAPI == GRAPHICS_API_DIRECT3D11_WIN32 ? TRUE : FALSE ;

	// VF[_[IuWFNgt@Ccw`kf[^𓀂
	switch( GRAWIN.Setting.UseGraphicsAPI )
	{
#ifndef DX_NON_DIRECT3D11
	case GRAPHICS_API_DIRECT3D11_WIN32 :
		if( Live2DCubism3_SetupShaderCode( &DxShaderCodeBin_Live2D_Cubism3_D3D11Convert, DxShaderCodeBin_Live2D_Cubism3_D3D11 ) < 0 )
		{
			return -1 ;
		}
		break ;
#endif // DX_NON_DIRECT3D11

#ifndef DX_NON_DIRECT3D9
	case GRAPHICS_API_DIRECT3D9_WIN32 :
		if( Live2DCubism3_SetupShaderCode( &DxShaderCodeBin_Live2D_Cubism3_D3D9Convert, DxShaderCodeBin_Live2D_Cubism3_D3D9 ) < 0 )
		{
			return -1 ;
		}
		break ;
#endif // DX_NON_DIRECT3D9

	default :
		return -1 ;
	}

	return 0 ;
}

// Live2D Cubism3 ֘Ǎn֐̊ˑs֐
extern int Live2DCubism3_Terminate_PF( void )
{
	// DLL ̃A[h
	Live2DCubism3_DLL_Unload() ;

	return 0 ;
}

// Live2D Cubism3 ̃VF[_[쐬̊ˑs
extern int Live2DCubism3_GenerateShaders_PF( void )
{
	return 0 ;
}

// VF[_[̃ZbgAbvs
extern int Live2DCubism3_SetupShader_PF( int ConstantBufferHandle, D_CubismConstantBufferDxLib *ConstantBuffer, D_ShaderNames VertexShader, D_ShaderNames PixelShader )
{
	D_CubismShader_DxLib* shaderManager = D_CubismRenderer_DxLib::GetShaderManager();

	if( shaderManager == NULL )
	{
		return -1 ;
	}

	NS_SetUseVertexShader( shaderManager->GetVertexShader( VertexShader ) );
	NS_SetUsePixelShader( shaderManager->GetPixelShader( PixelShader ) );

	if( LIVE2DSYS.EnableConstantBuffer )
	{
		// Update 
		NS_UpdateShaderConstantBuffer( ConstantBufferHandle ) ;

		// Zbg 
		NS_SetShaderConstantBuffer( ConstantBufferHandle, DX_SHADERTYPE_VERTEX, 0 ) ;
		NS_SetShaderConstantBuffer( ConstantBufferHandle, DX_SHADERTYPE_PIXEL, 0 ) ;
	}
	else
	{
		NS_SetVSConstFMtx( 0, ConstantBuffer->projectMatrix ) ;
		NS_SetVSConstFMtx( 4, ConstantBuffer->clipMatrix ) ;
		NS_SetPSConstF( 8, *( ( FLOAT4 * )&ConstantBuffer->baseColor ) ) ;
		NS_SetPSConstF( 9, *( ( FLOAT4 * )&ConstantBuffer->channelFlag ) ) ;
	}

	return 0 ;
}

// Live2D Cubism3 ̕`̌ɌĂ΂ˑ֐
extern int Live2DCubism3_DrawAfter_PF( void )
{
	if( LIVE2DSYS.EnableConstantBuffer == FALSE )
	{
		NS_ResetVSConstF( 0, 8 ) ;
		NS_ResetPSConstF( 8, 2 ) ;
	}

	return 0 ;
}

bool D_CubismShader_DxLib::LoadShaderProgram(bool isPs, int assign, const char* entryPoint)
{
    bool bRet = false;
	char FilePath[ 1024 ];

    int vertexShader = -1;
    int pixelShader = -1;

    do
    {
		CL_strcpy( DX_CHARCODEFORMAT_ASCII, FilePath, entryPoint );
		if( isPs )
		{
			CL_strcat( DX_CHARCODEFORMAT_ASCII, FilePath, ".pso" ) ;
			pixelShader = Live2DCubism3_LoadShaderCode( FilePath, DX_SHADERTYPE_PIXEL ) ;
			if( pixelShader < 0 )
			{
				// CubismLogWarning("Fail Create Shader");
				break;
			}
            _shaderSetsPS[assign] = pixelShader;
		}
		else
		{
			CL_strcat( DX_CHARCODEFORMAT_ASCII, FilePath, ".vso" ) ;
			vertexShader = Live2DCubism3_LoadShaderCode( FilePath, DX_SHADERTYPE_VERTEX ) ;
			if( vertexShader < 0 )
			{
				// CubismLogWarning("Fail Create Shader");
				break;
			}
            _shaderSetsVS[assign] = vertexShader;
		}
        //  
        bRet = true;
    } while (0);

    return bRet;
}

// #ifndef DX_NON_NAMESPACE
// 
// }
// 
// #endif // DX_NON_NAMESPACE

#endif // DX_NON_LIVE2D_CUBISM3

